/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Callback Function Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.ModelPackage#getCallbackFunctionType()
 * @model
 * @generated
 */
public enum CallbackFunctionType implements Enumerator {
	/**
	 * The '<em><b>Init</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INIT_VALUE
	 * @generated
	 * @ordered
	 */
	INIT(0, "Init", "Init"),

	/**
	 * The '<em><b>Process Activated</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PROCESS_ACTIVATED_VALUE
	 * @generated
	 * @ordered
	 */
	PROCESS_ACTIVATED(1, "ProcessActivated", "ProcessActivated"),

	/**
	 * The '<em><b>Process Blocked</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PROCESS_BLOCKED_VALUE
	 * @generated
	 * @ordered
	 */
	PROCESS_BLOCKED(2, "ProcessBlocked", "ProcessBlocked"),

	/**
	 * The '<em><b>Process Terminated</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PROCESS_TERMINATED_VALUE
	 * @generated
	 * @ordered
	 */
	PROCESS_TERMINATED(3, "ProcessTerminated", "ProcessTerminated"),

	/**
	 * The '<em><b>Process Unblocked</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PROCESS_UNBLOCKED_VALUE
	 * @generated
	 * @ordered
	 */
	PROCESS_UNBLOCKED(4, "ProcessUnblocked", "ProcessUnblocked"),

	/**
	 * The '<em><b>Cooperative Schedule</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #COOPERATIVE_SCHEDULE_VALUE
	 * @generated
	 * @ordered
	 */
	COOPERATIVE_SCHEDULE(5, "CooperativeSchedule", "CooperativeSchedule"),

	/**
	 * The '<em><b>Subscheduler Changed</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SUBSCHEDULER_CHANGED_VALUE
	 * @generated
	 * @ordered
	 */
	SUBSCHEDULER_CHANGED(6, "SubschedulerChanged", "SubschedulerChanged"),

	/**
	 * The '<em><b>Timer Expired</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIMER_EXPIRED_VALUE
	 * @generated
	 * @ordered
	 */
	TIMER_EXPIRED(7, "TimerExpired", "TimerExpired");

	/**
	 * The '<em><b>Init</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Init</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #INIT
	 * @model name="Init"
	 * @generated
	 * @ordered
	 */
	public static final int INIT_VALUE = 0;

	/**
	 * The '<em><b>Process Activated</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Process Activated</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PROCESS_ACTIVATED
	 * @model name="ProcessActivated"
	 * @generated
	 * @ordered
	 */
	public static final int PROCESS_ACTIVATED_VALUE = 1;

	/**
	 * The '<em><b>Process Blocked</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Process Blocked</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PROCESS_BLOCKED
	 * @model name="ProcessBlocked"
	 * @generated
	 * @ordered
	 */
	public static final int PROCESS_BLOCKED_VALUE = 2;

	/**
	 * The '<em><b>Process Terminated</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Process Terminated</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PROCESS_TERMINATED
	 * @model name="ProcessTerminated"
	 * @generated
	 * @ordered
	 */
	public static final int PROCESS_TERMINATED_VALUE = 3;

	/**
	 * The '<em><b>Process Unblocked</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Process Unblocked</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PROCESS_UNBLOCKED
	 * @model name="ProcessUnblocked"
	 * @generated
	 * @ordered
	 */
	public static final int PROCESS_UNBLOCKED_VALUE = 4;

	/**
	 * The '<em><b>Cooperative Schedule</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Cooperative Schedule</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #COOPERATIVE_SCHEDULE
	 * @model name="CooperativeSchedule"
	 * @generated
	 * @ordered
	 */
	public static final int COOPERATIVE_SCHEDULE_VALUE = 5;

	/**
	 * The '<em><b>Subscheduler Changed</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Subscheduler Changed</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SUBSCHEDULER_CHANGED
	 * @model name="SubschedulerChanged"
	 * @generated
	 * @ordered
	 */
	public static final int SUBSCHEDULER_CHANGED_VALUE = 6;

	/**
	 * The '<em><b>Timer Expired</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Timer Expired</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIMER_EXPIRED
	 * @model name="TimerExpired"
	 * @generated
	 * @ordered
	 */
	public static final int TIMER_EXPIRED_VALUE = 7;

	/**
	 * An array of all the '<em><b>Callback Function Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final CallbackFunctionType[] VALUES_ARRAY =
		new CallbackFunctionType[] {
			INIT,
			PROCESS_ACTIVATED,
			PROCESS_BLOCKED,
			PROCESS_TERMINATED,
			PROCESS_UNBLOCKED,
			COOPERATIVE_SCHEDULE,
			SUBSCHEDULER_CHANGED,
			TIMER_EXPIRED,
		};

	/**
	 * A public read-only list of all the '<em><b>Callback Function Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<CallbackFunctionType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Callback Function Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static CallbackFunctionType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			CallbackFunctionType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Callback Function Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static CallbackFunctionType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			CallbackFunctionType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Callback Function Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static CallbackFunctionType get(int value) {
		switch (value) {
			case INIT_VALUE: return INIT;
			case PROCESS_ACTIVATED_VALUE: return PROCESS_ACTIVATED;
			case PROCESS_BLOCKED_VALUE: return PROCESS_BLOCKED;
			case PROCESS_TERMINATED_VALUE: return PROCESS_TERMINATED;
			case PROCESS_UNBLOCKED_VALUE: return PROCESS_UNBLOCKED;
			case COOPERATIVE_SCHEDULE_VALUE: return COOPERATIVE_SCHEDULE;
			case SUBSCHEDULER_CHANGED_VALUE: return SUBSCHEDULER_CHANGED;
			case TIMER_EXPIRED_VALUE: return TIMER_EXPIRED;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private CallbackFunctionType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //CallbackFunctionType
