/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Conditional Trace Event</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.ConditionalTraceEvent#getTraceEvent <em>Trace Event</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ConditionalTraceEvent#getProcess <em>Process</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ConditionalTraceEvent#getValueConstraint <em>Value Constraint</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getConditionalTraceEvent()
 * @model
 * @generated
 */
public interface ConditionalTraceEvent extends EventChainStep {
	/**
	 * Returns the value of the '<em><b>Trace Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Trace Event</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Trace Event</em>' reference.
	 * @see #setTraceEvent(TraceEvent)
	 * @see com.inchron.realtime.root.model.ModelPackage#getConditionalTraceEvent_TraceEvent()
	 * @model
	 * @generated
	 */
	TraceEvent getTraceEvent();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ConditionalTraceEvent#getTraceEvent <em>Trace Event</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Trace Event</em>' reference.
	 * @see #getTraceEvent()
	 * @generated
	 */
	void setTraceEvent(TraceEvent value);

	/**
	 * Returns the value of the '<em><b>Process</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Process</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Process</em>' reference.
	 * @see #setProcess(com.inchron.realtime.root.model.Process)
	 * @see com.inchron.realtime.root.model.ModelPackage#getConditionalTraceEvent_Process()
	 * @model
	 * @generated
	 */
	com.inchron.realtime.root.model.Process getProcess();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ConditionalTraceEvent#getProcess <em>Process</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Process</em>' reference.
	 * @see #getProcess()
	 * @generated
	 */
	void setProcess(com.inchron.realtime.root.model.Process value);

	/**
	 * Returns the value of the '<em><b>Value Constraint</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Value Constraint</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Value Constraint</em>' attribute.
	 * @see #setValueConstraint(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getConditionalTraceEvent_ValueConstraint()
	 * @model
	 * @generated
	 */
	String getValueConstraint();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ConditionalTraceEvent#getValueConstraint <em>Value Constraint</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Value Constraint</em>' attribute.
	 * @see #getValueConstraint()
	 * @generated
	 */
	void setValueConstraint(String value);

} // ConditionalTraceEvent
