/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Data Flow Reference</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.DataFlowReference#getDataFlow <em>Data Flow</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.DataFlowReference#getStimulus <em>Stimulus</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.DataFlowReference#getResponse <em>Response</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowReference()
 * @model
 * @generated
 */
public interface DataFlowReference extends EObject {
	/**
	 * Returns the value of the '<em><b>Data Flow</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Data Flow</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Data Flow</em>' reference.
	 * @see #setDataFlow(DataFlow)
	 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowReference_DataFlow()
	 * @model required="true"
	 * @generated
	 */
	DataFlow getDataFlow();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.DataFlowReference#getDataFlow <em>Data Flow</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Data Flow</em>' reference.
	 * @see #getDataFlow()
	 * @generated
	 */
	void setDataFlow(DataFlow value);

	/**
	 * Returns the value of the '<em><b>Stimulus</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stimulus</em>' reference.
	 * @see #setStimulus(VariableAccess)
	 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowReference_Stimulus()
	 * @model required="true"
	 * @generated
	 */
	VariableAccess getStimulus();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.DataFlowReference#getStimulus <em>Stimulus</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stimulus</em>' reference.
	 * @see #getStimulus()
	 * @generated
	 */
	void setStimulus(VariableAccess value);

	/**
	 * Returns the value of the '<em><b>Response</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Response</em>' reference.
	 * @see #setResponse(VariableAccess)
	 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowReference_Response()
	 * @model required="true"
	 * @generated
	 */
	VariableAccess getResponse();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.DataFlowReference#getResponse <em>Response</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Response</em>' reference.
	 * @see #getResponse()
	 * @generated
	 */
	void setResponse(VariableAccess value);

} // DataFlowReference
