/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Mode Switch Entry</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.ModeSwitchEntry#getCondition <em>Condition</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ModeSwitchEntry#getGraphEntries <em>Graph Entries</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ModeSwitchEntry#isNegated <em>Negated</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getModeSwitchEntry()
 * @model
 * @generated
 */
public interface ModeSwitchEntry extends EObject {
	/**
	 * Returns the value of the '<em><b>Condition</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Condition</em>' reference.
	 * @see #setCondition(ModeCondition)
	 * @see com.inchron.realtime.root.model.ModelPackage#getModeSwitchEntry_Condition()
	 * @model required="true"
	 * @generated
	 */
	ModeCondition getCondition();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ModeSwitchEntry#getCondition <em>Condition</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Condition</em>' reference.
	 * @see #getCondition()
	 * @generated
	 */
	void setCondition(ModeCondition value);

	/**
	 * Returns the value of the '<em><b>Graph Entries</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.GraphEntryBase}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Graph Entries</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Graph Entries</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModeSwitchEntry_GraphEntries()
	 * @model containment="true"
	 * @generated
	 */
	EList<GraphEntryBase> getGraphEntries();

	/**
	 * Returns the value of the '<em><b>Negated</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Negated</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Negated</em>' attribute.
	 * @see #setNegated(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getModeSwitchEntry_Negated()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isNegated();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ModeSwitchEntry#isNegated <em>Negated</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Negated</em>' attribute.
	 * @see #isNegated()
	 * @generated
	 */
	void setNegated(boolean value);

} // ModeSwitchEntry
