/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Rtos Property</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.ModelPackage#getRtosProperty()
 * @model
 * @generated
 */
public enum RtosProperty implements Enumerator {
	/**
	 * The '<em><b>Bare</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BARE_VALUE
	 * @generated
	 * @ordered
	 */
	BARE(0, "Bare", "Bare"),

	/**
	 * The '<em><b>Explicit Task Definition</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EXPLICIT_TASK_DEFINITION_VALUE
	 * @generated
	 * @ordered
	 */
	EXPLICIT_TASK_DEFINITION(1, "ExplicitTaskDefinition", "ExplicitTaskDefinition"),

	/**
	 * The '<em><b>Suspend When Task Returns</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SUSPEND_WHEN_TASK_RETURNS_VALUE
	 * @generated
	 * @ordered
	 */
	SUSPEND_WHEN_TASK_RETURNS(2, "SuspendWhenTaskReturns", "SuspendWhenTaskReturns"),

	/**
	 * The '<em><b>Task Return Forbidden</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TASK_RETURN_FORBIDDEN_VALUE
	 * @generated
	 * @ordered
	 */
	TASK_RETURN_FORBIDDEN(4, "TaskReturnForbidden", "TaskReturnForbidden"),

	/**
	 * The '<em><b>Resource Needs Init</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #RESOURCE_NEEDS_INIT_VALUE
	 * @generated
	 * @ordered
	 */
	RESOURCE_NEEDS_INIT(8, "ResourceNeedsInit", "ResourceNeedsInit"),

	/**
	 * The '<em><b>Autosar RTE Events</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #AUTOSAR_RTE_EVENTS_VALUE
	 * @generated
	 * @ordered
	 */
	AUTOSAR_RTE_EVENTS(16, "AutosarRTEEvents", "AutosarRTEEvents"),

	/**
	 * The '<em><b>Extended Task</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EXTENDED_TASK_VALUE
	 * @generated
	 * @ordered
	 */
	EXTENDED_TASK(32, "ExtendedTask", "ExtendedTask"),

	/**
	 * The '<em><b>Osek</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #OSEK_VALUE
	 * @generated
	 * @ordered
	 */
	OSEK(15, "Osek", "Osek");

	/**
	 * The '<em><b>Bare</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Bare</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #BARE
	 * @model name="Bare"
	 * @generated
	 * @ordered
	 */
	public static final int BARE_VALUE = 0;

	/**
	 * The '<em><b>Explicit Task Definition</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Explicit Task Definition</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #EXPLICIT_TASK_DEFINITION
	 * @model name="ExplicitTaskDefinition"
	 * @generated
	 * @ordered
	 */
	public static final int EXPLICIT_TASK_DEFINITION_VALUE = 1;

	/**
	 * The '<em><b>Suspend When Task Returns</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Suspend When Task Returns</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SUSPEND_WHEN_TASK_RETURNS
	 * @model name="SuspendWhenTaskReturns"
	 * @generated
	 * @ordered
	 */
	public static final int SUSPEND_WHEN_TASK_RETURNS_VALUE = 2;

	/**
	 * The '<em><b>Task Return Forbidden</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Task Return Forbidden</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TASK_RETURN_FORBIDDEN
	 * @model name="TaskReturnForbidden"
	 * @generated
	 * @ordered
	 */
	public static final int TASK_RETURN_FORBIDDEN_VALUE = 4;

	/**
	 * The '<em><b>Resource Needs Init</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Resource Needs Init</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #RESOURCE_NEEDS_INIT
	 * @model name="ResourceNeedsInit"
	 * @generated
	 * @ordered
	 */
	public static final int RESOURCE_NEEDS_INIT_VALUE = 8;

	/**
	 * The '<em><b>Autosar RTE Events</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Autosar RTE Events</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #AUTOSAR_RTE_EVENTS
	 * @model name="AutosarRTEEvents"
	 * @generated
	 * @ordered
	 */
	public static final int AUTOSAR_RTE_EVENTS_VALUE = 16;

	/**
	 * The '<em><b>Extended Task</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Extended Task</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #EXTENDED_TASK
	 * @model name="ExtendedTask"
	 * @generated
	 * @ordered
	 */
	public static final int EXTENDED_TASK_VALUE = 32;

	/**
	 * The '<em><b>Osek</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Osek</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #OSEK
	 * @model name="Osek"
	 * @generated
	 * @ordered
	 */
	public static final int OSEK_VALUE = 15;

	/**
	 * An array of all the '<em><b>Rtos Property</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final RtosProperty[] VALUES_ARRAY =
		new RtosProperty[] {
			BARE,
			EXPLICIT_TASK_DEFINITION,
			SUSPEND_WHEN_TASK_RETURNS,
			TASK_RETURN_FORBIDDEN,
			RESOURCE_NEEDS_INIT,
			AUTOSAR_RTE_EVENTS,
			EXTENDED_TASK,
			OSEK,
		};

	/**
	 * A public read-only list of all the '<em><b>Rtos Property</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<RtosProperty> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Rtos Property</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static RtosProperty get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RtosProperty result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Rtos Property</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static RtosProperty getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RtosProperty result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Rtos Property</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static RtosProperty get(int value) {
		switch (value) {
			case BARE_VALUE: return BARE;
			case EXPLICIT_TASK_DEFINITION_VALUE: return EXPLICIT_TASK_DEFINITION;
			case SUSPEND_WHEN_TASK_RETURNS_VALUE: return SUSPEND_WHEN_TASK_RETURNS;
			case TASK_RETURN_FORBIDDEN_VALUE: return TASK_RETURN_FORBIDDEN;
			case RESOURCE_NEEDS_INIT_VALUE: return RESOURCE_NEEDS_INIT;
			case AUTOSAR_RTE_EVENTS_VALUE: return AUTOSAR_RTE_EVENTS;
			case EXTENDED_TASK_VALUE: return EXTENDED_TASK;
			case OSEK_VALUE: return OSEK;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private RtosProperty(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //RtosProperty
