/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Spec Settings</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.SpecSettings#getIncludes <em>Includes</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.SpecSettings#getMacros <em>Macros</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.SpecSettings#isPrependSettings <em>Prepend Settings</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getSpecSettings()
 * @model
 * @generated
 */
public interface SpecSettings extends EObject {
	/**
	 * Returns the value of the '<em><b>Includes</b></em>' attribute.
	 * The default value is <code>" "</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Includes</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Includes</em>' attribute.
	 * @see #setIncludes(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSpecSettings_Includes()
	 * @model default=" " ordered="false"
	 * @generated
	 */
	String getIncludes();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.SpecSettings#getIncludes <em>Includes</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Includes</em>' attribute.
	 * @see #getIncludes()
	 * @generated
	 */
	void setIncludes(String value);

	/**
	 * Returns the value of the '<em><b>Macros</b></em>' attribute.
	 * The default value is <code>" "</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Macros</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Macros</em>' attribute.
	 * @see #setMacros(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSpecSettings_Macros()
	 * @model default=" " required="true" ordered="false"
	 * @generated
	 */
	String getMacros();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.SpecSettings#getMacros <em>Macros</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Macros</em>' attribute.
	 * @see #getMacros()
	 * @generated
	 */
	void setMacros(String value);

	/**
	 * Returns the value of the '<em><b>Prepend Settings</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Prepend Settings</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Prepend Settings</em>' attribute.
	 * @see #setPrependSettings(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSpecSettings_PrependSettings()
	 * @model default="false" required="true" ordered="false"
	 * @generated
	 */
	boolean isPrependSettings();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.SpecSettings#isPrependSettings <em>Prepend Settings</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Prepend Settings</em>' attribute.
	 * @see #isPrependSettings()
	 * @generated
	 */
	void setPrependSettings(boolean value);

} // SpecSettings
