/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Variable Write Access</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.VariableWriteAccess#getConnection <em>Connection</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableWriteAccess#getDelay <em>Delay</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableWriteAccess#getType <em>Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableWriteAccess#getPolicy <em>Policy</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getVariableWriteAccess()
 * @model
 * @generated
 */
public interface VariableWriteAccess extends VariableAccess {
	/**
	 * Returns the value of the '<em><b>Connection</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.DataFlowConnection#getProvider <em>Provider</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connection</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connection</em>' reference.
	 * @see #setConnection(DataFlowConnection)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableWriteAccess_Connection()
	 * @see com.inchron.realtime.root.model.DataFlowConnection#getProvider
	 * @model opposite="provider"
	 * @generated
	 */
	DataFlowConnection getConnection();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableWriteAccess#getConnection <em>Connection</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Connection</em>' reference.
	 * @see #getConnection()
	 * @generated
	 */
	void setConnection(DataFlowConnection value);

	/**
	 * Returns the value of the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Delay</em>' containment reference.
	 * @see #setDelay(TimeDistribution)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableWriteAccess_Delay()
	 * @model containment="true"
	 * @generated
	 */
	TimeDistribution getDelay();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableWriteAccess#getDelay <em>Delay</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Delay</em>' containment reference.
	 * @see #getDelay()
	 * @generated
	 */
	void setDelay(TimeDistribution value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>"Generic"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.VariableWriteAccessType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.VariableWriteAccessType
	 * @see #setType(VariableWriteAccessType)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableWriteAccess_Type()
	 * @model default="Generic" required="true"
	 * @generated
	 */
	VariableWriteAccessType getType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableWriteAccess#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.VariableWriteAccessType
	 * @see #getType()
	 * @generated
	 */
	void setType(VariableWriteAccessType value);

	/**
	 * Returns the value of the '<em><b>Policy</b></em>' attribute.
	 * The default value is <code>"ErrorDrop"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.VariableWriteAccessPolicy}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Policy</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Policy</em>' attribute.
	 * @see com.inchron.realtime.root.model.VariableWriteAccessPolicy
	 * @see #setPolicy(VariableWriteAccessPolicy)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableWriteAccess_Policy()
	 * @model default="ErrorDrop" required="true"
	 * @generated
	 */
	VariableWriteAccessPolicy getPolicy();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableWriteAccess#getPolicy <em>Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Policy</em>' attribute.
	 * @see com.inchron.realtime.root.model.VariableWriteAccessPolicy
	 * @see #getPolicy()
	 * @generated
	 */
	void setPolicy(VariableWriteAccessPolicy value);

} // VariableWriteAccess
