/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Os Isr</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsIsr#getResources <em>Resources</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsIsr#getType <em>Type</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsIsr()
 * @model
 * @generated
 */
public interface OsIsr extends com.inchron.realtime.root.model.Process {
	/**
	 * Returns the value of the '<em><b>Resources</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsResource}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Resources</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Resources</em>' reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsIsr_Resources()
	 * @model
	 * @generated
	 */
	EList<OsResource> getResources();

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>"Category2"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.autosar.OsIsrType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.autosar.OsIsrType
	 * @see #setType(OsIsrType)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsIsr_Type()
	 * @model default="Category2"
	 * @generated
	 */
	OsIsrType getType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsIsr#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.autosar.OsIsrType
	 * @see #getType()
	 * @generated
	 */
	void setType(OsIsrType value);

} // OsIsr
