/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Os Spinlock Lock Method</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsSpinlockLockMethod()
 * @model
 * @generated
 */
public enum OsSpinlockLockMethod implements Enumerator {
	/**
	 * The '<em><b>Lock Nothing</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LOCK_NOTHING_VALUE
	 * @generated
	 * @ordered
	 */
	LOCK_NOTHING(0, "LockNothing", "LockNothing"),

	/**
	 * The '<em><b>Lock All Interrupts</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LOCK_ALL_INTERRUPTS_VALUE
	 * @generated
	 * @ordered
	 */
	LOCK_ALL_INTERRUPTS(1, "LockAllInterrupts", "LockAllInterrupts"),

	/**
	 * The '<em><b>Lock Cat2 Interrupts</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LOCK_CAT2_INTERRUPTS_VALUE
	 * @generated
	 * @ordered
	 */
	LOCK_CAT2_INTERRUPTS(2, "LockCat2Interrupts", "LockCat2Interrupts"),

	/**
	 * The '<em><b>Lock With Res Scheduler</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LOCK_WITH_RES_SCHEDULER_VALUE
	 * @generated
	 * @ordered
	 */
	LOCK_WITH_RES_SCHEDULER(3, "LockWithResScheduler", "LockWithResScheduler");

	/**
	 * The '<em><b>Lock Nothing</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Lock Nothing</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #LOCK_NOTHING
	 * @model name="LockNothing"
	 * @generated
	 * @ordered
	 */
	public static final int LOCK_NOTHING_VALUE = 0;

	/**
	 * The '<em><b>Lock All Interrupts</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Lock All Interrupts</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #LOCK_ALL_INTERRUPTS
	 * @model name="LockAllInterrupts"
	 * @generated
	 * @ordered
	 */
	public static final int LOCK_ALL_INTERRUPTS_VALUE = 1;

	/**
	 * The '<em><b>Lock Cat2 Interrupts</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Lock Cat2 Interrupts</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #LOCK_CAT2_INTERRUPTS
	 * @model name="LockCat2Interrupts"
	 * @generated
	 * @ordered
	 */
	public static final int LOCK_CAT2_INTERRUPTS_VALUE = 2;

	/**
	 * The '<em><b>Lock With Res Scheduler</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Lock With Res Scheduler</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #LOCK_WITH_RES_SCHEDULER
	 * @model name="LockWithResScheduler"
	 * @generated
	 * @ordered
	 */
	public static final int LOCK_WITH_RES_SCHEDULER_VALUE = 3;

	/**
	 * An array of all the '<em><b>Os Spinlock Lock Method</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final OsSpinlockLockMethod[] VALUES_ARRAY =
		new OsSpinlockLockMethod[] {
			LOCK_NOTHING,
			LOCK_ALL_INTERRUPTS,
			LOCK_CAT2_INTERRUPTS,
			LOCK_WITH_RES_SCHEDULER,
		};

	/**
	 * A public read-only list of all the '<em><b>Os Spinlock Lock Method</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<OsSpinlockLockMethod> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Os Spinlock Lock Method</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static OsSpinlockLockMethod get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			OsSpinlockLockMethod result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Os Spinlock Lock Method</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static OsSpinlockLockMethod getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			OsSpinlockLockMethod result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Os Spinlock Lock Method</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static OsSpinlockLockMethod get(int value) {
		switch (value) {
			case LOCK_NOTHING_VALUE: return LOCK_NOTHING;
			case LOCK_ALL_INTERRUPTS_VALUE: return LOCK_ALL_INTERRUPTS;
			case LOCK_CAT2_INTERRUPTS_VALUE: return LOCK_CAT2_INTERRUPTS;
			case LOCK_WITH_RES_SCHEDULER_VALUE: return LOCK_WITH_RES_SCHEDULER;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private OsSpinlockLockMethod(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //OsSpinlockLockMethod
