/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar.impl;

import com.inchron.realtime.root.model.Mode;

import com.inchron.realtime.root.model.autosar.AutosarPackage;

import com.inchron.realtime.root.model.impl.FunctionImpl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Runnable</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.RunnableImpl#isCanBeInvokedConcurrently <em>Can Be Invoked Concurrently</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.RunnableImpl#getDisabledInMode <em>Disabled In Mode</em>}</li>
 * </ul>
 *
 * @generated
 */
public class RunnableImpl extends FunctionImpl implements com.inchron.realtime.root.model.autosar.Runnable {
	/**
	 * The default value of the '{@link #isCanBeInvokedConcurrently() <em>Can Be Invoked Concurrently</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isCanBeInvokedConcurrently()
	 * @generated
	 * @ordered
	 */
	protected static final boolean CAN_BE_INVOKED_CONCURRENTLY_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isCanBeInvokedConcurrently() <em>Can Be Invoked Concurrently</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isCanBeInvokedConcurrently()
	 * @generated
	 * @ordered
	 */
	protected boolean canBeInvokedConcurrently = CAN_BE_INVOKED_CONCURRENTLY_EDEFAULT;

	/**
	 * The cached value of the '{@link #getDisabledInMode() <em>Disabled In Mode</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisabledInMode()
	 * @generated
	 * @ordered
	 */
	protected Mode disabledInMode;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RunnableImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AutosarPackage.Literals.RUNNABLE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isCanBeInvokedConcurrently() {
		return canBeInvokedConcurrently;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCanBeInvokedConcurrently(boolean newCanBeInvokedConcurrently) {
		boolean oldCanBeInvokedConcurrently = canBeInvokedConcurrently;
		canBeInvokedConcurrently = newCanBeInvokedConcurrently;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.RUNNABLE__CAN_BE_INVOKED_CONCURRENTLY, oldCanBeInvokedConcurrently, canBeInvokedConcurrently));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Mode getDisabledInMode() {
		if (disabledInMode != null && disabledInMode.eIsProxy()) {
			InternalEObject oldDisabledInMode = (InternalEObject)disabledInMode;
			disabledInMode = (Mode)eResolveProxy(oldDisabledInMode);
			if (disabledInMode != oldDisabledInMode) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AutosarPackage.RUNNABLE__DISABLED_IN_MODE, oldDisabledInMode, disabledInMode));
			}
		}
		return disabledInMode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Mode basicGetDisabledInMode() {
		return disabledInMode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDisabledInMode(Mode newDisabledInMode) {
		Mode oldDisabledInMode = disabledInMode;
		disabledInMode = newDisabledInMode;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.RUNNABLE__DISABLED_IN_MODE, oldDisabledInMode, disabledInMode));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AutosarPackage.RUNNABLE__CAN_BE_INVOKED_CONCURRENTLY:
				return isCanBeInvokedConcurrently();
			case AutosarPackage.RUNNABLE__DISABLED_IN_MODE:
				if (resolve) return getDisabledInMode();
				return basicGetDisabledInMode();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AutosarPackage.RUNNABLE__CAN_BE_INVOKED_CONCURRENTLY:
				setCanBeInvokedConcurrently((Boolean)newValue);
				return;
			case AutosarPackage.RUNNABLE__DISABLED_IN_MODE:
				setDisabledInMode((Mode)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AutosarPackage.RUNNABLE__CAN_BE_INVOKED_CONCURRENTLY:
				setCanBeInvokedConcurrently(CAN_BE_INVOKED_CONCURRENTLY_EDEFAULT);
				return;
			case AutosarPackage.RUNNABLE__DISABLED_IN_MODE:
				setDisabledInMode((Mode)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AutosarPackage.RUNNABLE__CAN_BE_INVOKED_CONCURRENTLY:
				return canBeInvokedConcurrently != CAN_BE_INVOKED_CONCURRENTLY_EDEFAULT;
			case AutosarPackage.RUNNABLE__DISABLED_IN_MODE:
				return disabledInMode != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (canBeInvokedConcurrently: ");
		result.append(canBeInvokedConcurrently);
		result.append(')');
		return result.toString();
	}

} //RunnableImpl
