/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.variable;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Enumeration</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getDeclaredType <em>Declared Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getMax <em>Max</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getMin <em>Min</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getQuantity <em>Quantity</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getStart <em>Start</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getEnumeration()
 * @model
 * @generated
 */
public interface Enumeration extends ScalarVariable {
	/**
	 * Returns the value of the '<em><b>Declared Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Declared Type</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Declared Type</em>' reference.
	 * @see #setDeclaredType(com.inchron.realtime.root.model.fmi.type.Enumeration)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getEnumeration_DeclaredType()
	 * @model required="true"
	 * @generated
	 */
	com.inchron.realtime.root.model.fmi.type.Enumeration getDeclaredType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getDeclaredType <em>Declared Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Declared Type</em>' reference.
	 * @see #getDeclaredType()
	 * @generated
	 */
	void setDeclaredType(com.inchron.realtime.root.model.fmi.type.Enumeration value);

	/**
	 * Returns the value of the '<em><b>Max</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max</em>' attribute.
	 * @see #setMax(int)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getEnumeration_Max()
	 * @model default="0"
	 * @generated
	 */
	int getMax();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getMax <em>Max</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max</em>' attribute.
	 * @see #getMax()
	 * @generated
	 */
	void setMax(int value);

	/**
	 * Returns the value of the '<em><b>Min</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Min</em>' attribute.
	 * @see #setMin(int)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getEnumeration_Min()
	 * @model default="0"
	 * @generated
	 */
	int getMin();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getMin <em>Min</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Min</em>' attribute.
	 * @see #getMin()
	 * @generated
	 */
	void setMin(int value);

	/**
	 * Returns the value of the '<em><b>Quantity</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Quantity</em>' attribute.
	 * @see #setQuantity(String)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getEnumeration_Quantity()
	 * @model default=""
	 * @generated
	 */
	String getQuantity();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getQuantity <em>Quantity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Quantity</em>' attribute.
	 * @see #getQuantity()
	 * @generated
	 */
	void setQuantity(String value);

	/**
	 * Returns the value of the '<em><b>Start</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start</em>' attribute.
	 * @see #setStart(int)
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#getEnumeration_Start()
	 * @model default="0"
	 * @generated
	 */
	int getStart();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getStart <em>Start</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start</em>' attribute.
	 * @see #getStart()
	 * @generated
	 */
	void setStart(int value);

} // Enumeration
