/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.variable.impl;

import com.inchron.realtime.root.model.fmi.FmiPackage;
import com.inchron.realtime.root.model.fmi.RealAttributes;

import com.inchron.realtime.root.model.fmi.unit.DisplayUnit;
import com.inchron.realtime.root.model.fmi.unit.Unit;

import com.inchron.realtime.root.model.fmi.variable.Real;
import com.inchron.realtime.root.model.fmi.variable.VariablePackage;

import java.lang.Boolean;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Real</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.RealImpl#getDisplayUnit <em>Display Unit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.RealImpl#getMax <em>Max</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.RealImpl#getMin <em>Min</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.RealImpl#getQuantity <em>Quantity</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.RealImpl#isRelativeQuantity <em>Relative Quantity</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.RealImpl#getUnit <em>Unit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.RealImpl#getDeclaredType <em>Declared Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.variable.impl.RealImpl#getStart <em>Start</em>}</li>
 * </ul>
 *
 * @generated
 */
public class RealImpl extends ScalarVariableImpl implements Real {
	/**
	 * The cached value of the '{@link #getDisplayUnit() <em>Display Unit</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisplayUnit()
	 * @generated
	 * @ordered
	 */
	protected DisplayUnit displayUnit;

	/**
	 * The default value of the '{@link #getMax() <em>Max</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMax()
	 * @generated
	 * @ordered
	 */
	protected static final double MAX_EDEFAULT = 1.7976931348623157E308;

	/**
	 * The cached value of the '{@link #getMax() <em>Max</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMax()
	 * @generated
	 * @ordered
	 */
	protected double max = MAX_EDEFAULT;

	/**
	 * The default value of the '{@link #getMin() <em>Min</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMin()
	 * @generated
	 * @ordered
	 */
	protected static final double MIN_EDEFAULT = -1.7976931348623157E308;

	/**
	 * The cached value of the '{@link #getMin() <em>Min</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMin()
	 * @generated
	 * @ordered
	 */
	protected double min = MIN_EDEFAULT;

	/**
	 * The default value of the '{@link #getQuantity() <em>Quantity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getQuantity()
	 * @generated
	 * @ordered
	 */
	protected static final String QUANTITY_EDEFAULT = "";

	/**
	 * The cached value of the '{@link #getQuantity() <em>Quantity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getQuantity()
	 * @generated
	 * @ordered
	 */
	protected String quantity = QUANTITY_EDEFAULT;

	/**
	 * The default value of the '{@link #isRelativeQuantity() <em>Relative Quantity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRelativeQuantity()
	 * @generated
	 * @ordered
	 */
	protected static final boolean RELATIVE_QUANTITY_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isRelativeQuantity() <em>Relative Quantity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRelativeQuantity()
	 * @generated
	 * @ordered
	 */
	protected boolean relativeQuantity = RELATIVE_QUANTITY_EDEFAULT;

	/**
	 * The cached value of the '{@link #getUnit() <em>Unit</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUnit()
	 * @generated
	 * @ordered
	 */
	protected Unit unit;

	/**
	 * The cached value of the '{@link #getDeclaredType() <em>Declared Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeclaredType()
	 * @generated
	 * @ordered
	 */
	protected com.inchron.realtime.root.model.fmi.type.Real declaredType;

	/**
	 * The default value of the '{@link #getStart() <em>Start</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStart()
	 * @generated
	 * @ordered
	 */
	protected static final double START_EDEFAULT = 0.0;

	/**
	 * The cached value of the '{@link #getStart() <em>Start</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStart()
	 * @generated
	 * @ordered
	 */
	protected double start = START_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RealImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return VariablePackage.Literals.REAL;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DisplayUnit getDisplayUnit() {
		if (displayUnit != null && displayUnit.eIsProxy()) {
			InternalEObject oldDisplayUnit = (InternalEObject)displayUnit;
			displayUnit = (DisplayUnit)eResolveProxy(oldDisplayUnit);
			if (displayUnit != oldDisplayUnit) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, VariablePackage.REAL__DISPLAY_UNIT, oldDisplayUnit, displayUnit));
			}
		}
		return displayUnit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DisplayUnit basicGetDisplayUnit() {
		return displayUnit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDisplayUnit(DisplayUnit newDisplayUnit) {
		DisplayUnit oldDisplayUnit = displayUnit;
		displayUnit = newDisplayUnit;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.REAL__DISPLAY_UNIT, oldDisplayUnit, displayUnit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getMax() {
		return max;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMax(double newMax) {
		double oldMax = max;
		max = newMax;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.REAL__MAX, oldMax, max));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getMin() {
		return min;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMin(double newMin) {
		double oldMin = min;
		min = newMin;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.REAL__MIN, oldMin, min));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getQuantity() {
		return quantity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setQuantity(String newQuantity) {
		String oldQuantity = quantity;
		quantity = newQuantity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.REAL__QUANTITY, oldQuantity, quantity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isRelativeQuantity() {
		return relativeQuantity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRelativeQuantity(boolean newRelativeQuantity) {
		boolean oldRelativeQuantity = relativeQuantity;
		relativeQuantity = newRelativeQuantity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.REAL__RELATIVE_QUANTITY, oldRelativeQuantity, relativeQuantity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Unit getUnit() {
		if (unit != null && unit.eIsProxy()) {
			InternalEObject oldUnit = (InternalEObject)unit;
			unit = (Unit)eResolveProxy(oldUnit);
			if (unit != oldUnit) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, VariablePackage.REAL__UNIT, oldUnit, unit));
			}
		}
		return unit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Unit basicGetUnit() {
		return unit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUnit(Unit newUnit) {
		Unit oldUnit = unit;
		unit = newUnit;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.REAL__UNIT, oldUnit, unit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.fmi.type.Real getDeclaredType() {
		if (declaredType != null && declaredType.eIsProxy()) {
			InternalEObject oldDeclaredType = (InternalEObject)declaredType;
			declaredType = (com.inchron.realtime.root.model.fmi.type.Real)eResolveProxy(oldDeclaredType);
			if (declaredType != oldDeclaredType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, VariablePackage.REAL__DECLARED_TYPE, oldDeclaredType, declaredType));
			}
		}
		return declaredType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.fmi.type.Real basicGetDeclaredType() {
		return declaredType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDeclaredType(com.inchron.realtime.root.model.fmi.type.Real newDeclaredType) {
		com.inchron.realtime.root.model.fmi.type.Real oldDeclaredType = declaredType;
		declaredType = newDeclaredType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.REAL__DECLARED_TYPE, oldDeclaredType, declaredType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getStart() {
		return start;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStart(double newStart) {
		double oldStart = start;
		start = newStart;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VariablePackage.REAL__START, oldStart, start));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case VariablePackage.REAL__DISPLAY_UNIT:
				if (resolve) return getDisplayUnit();
				return basicGetDisplayUnit();
			case VariablePackage.REAL__MAX:
				return getMax();
			case VariablePackage.REAL__MIN:
				return getMin();
			case VariablePackage.REAL__QUANTITY:
				return getQuantity();
			case VariablePackage.REAL__RELATIVE_QUANTITY:
				return isRelativeQuantity();
			case VariablePackage.REAL__UNIT:
				if (resolve) return getUnit();
				return basicGetUnit();
			case VariablePackage.REAL__DECLARED_TYPE:
				if (resolve) return getDeclaredType();
				return basicGetDeclaredType();
			case VariablePackage.REAL__START:
				return getStart();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case VariablePackage.REAL__DISPLAY_UNIT:
				setDisplayUnit((DisplayUnit)newValue);
				return;
			case VariablePackage.REAL__MAX:
				setMax((Double)newValue);
				return;
			case VariablePackage.REAL__MIN:
				setMin((Double)newValue);
				return;
			case VariablePackage.REAL__QUANTITY:
				setQuantity((String)newValue);
				return;
			case VariablePackage.REAL__RELATIVE_QUANTITY:
				setRelativeQuantity((Boolean)newValue);
				return;
			case VariablePackage.REAL__UNIT:
				setUnit((Unit)newValue);
				return;
			case VariablePackage.REAL__DECLARED_TYPE:
				setDeclaredType((com.inchron.realtime.root.model.fmi.type.Real)newValue);
				return;
			case VariablePackage.REAL__START:
				setStart((Double)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case VariablePackage.REAL__DISPLAY_UNIT:
				setDisplayUnit((DisplayUnit)null);
				return;
			case VariablePackage.REAL__MAX:
				setMax(MAX_EDEFAULT);
				return;
			case VariablePackage.REAL__MIN:
				setMin(MIN_EDEFAULT);
				return;
			case VariablePackage.REAL__QUANTITY:
				setQuantity(QUANTITY_EDEFAULT);
				return;
			case VariablePackage.REAL__RELATIVE_QUANTITY:
				setRelativeQuantity(RELATIVE_QUANTITY_EDEFAULT);
				return;
			case VariablePackage.REAL__UNIT:
				setUnit((Unit)null);
				return;
			case VariablePackage.REAL__DECLARED_TYPE:
				setDeclaredType((com.inchron.realtime.root.model.fmi.type.Real)null);
				return;
			case VariablePackage.REAL__START:
				setStart(START_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case VariablePackage.REAL__DISPLAY_UNIT:
				return displayUnit != null;
			case VariablePackage.REAL__MAX:
				return max != MAX_EDEFAULT;
			case VariablePackage.REAL__MIN:
				return min != MIN_EDEFAULT;
			case VariablePackage.REAL__QUANTITY:
				return QUANTITY_EDEFAULT == null ? quantity != null : !QUANTITY_EDEFAULT.equals(quantity);
			case VariablePackage.REAL__RELATIVE_QUANTITY:
				return relativeQuantity != RELATIVE_QUANTITY_EDEFAULT;
			case VariablePackage.REAL__UNIT:
				return unit != null;
			case VariablePackage.REAL__DECLARED_TYPE:
				return declaredType != null;
			case VariablePackage.REAL__START:
				return start != START_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == RealAttributes.class) {
			switch (derivedFeatureID) {
				case VariablePackage.REAL__DISPLAY_UNIT: return FmiPackage.REAL_ATTRIBUTES__DISPLAY_UNIT;
				case VariablePackage.REAL__MAX: return FmiPackage.REAL_ATTRIBUTES__MAX;
				case VariablePackage.REAL__MIN: return FmiPackage.REAL_ATTRIBUTES__MIN;
				case VariablePackage.REAL__QUANTITY: return FmiPackage.REAL_ATTRIBUTES__QUANTITY;
				case VariablePackage.REAL__RELATIVE_QUANTITY: return FmiPackage.REAL_ATTRIBUTES__RELATIVE_QUANTITY;
				case VariablePackage.REAL__UNIT: return FmiPackage.REAL_ATTRIBUTES__UNIT;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == RealAttributes.class) {
			switch (baseFeatureID) {
				case FmiPackage.REAL_ATTRIBUTES__DISPLAY_UNIT: return VariablePackage.REAL__DISPLAY_UNIT;
				case FmiPackage.REAL_ATTRIBUTES__MAX: return VariablePackage.REAL__MAX;
				case FmiPackage.REAL_ATTRIBUTES__MIN: return VariablePackage.REAL__MIN;
				case FmiPackage.REAL_ATTRIBUTES__QUANTITY: return VariablePackage.REAL__QUANTITY;
				case FmiPackage.REAL_ATTRIBUTES__RELATIVE_QUANTITY: return VariablePackage.REAL__RELATIVE_QUANTITY;
				case FmiPackage.REAL_ATTRIBUTES__UNIT: return VariablePackage.REAL__UNIT;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (max: ");
		result.append(max);
		result.append(", min: ");
		result.append(min);
		result.append(", quantity: ");
		result.append(quantity);
		result.append(", relativeQuantity: ");
		result.append(relativeQuantity);
		result.append(", start: ");
		result.append(start);
		result.append(')');
		return result.toString();
	}

} //RealImpl
