/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.CompilerSettings;
import com.inchron.realtime.root.model.ModelPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Compiler Settings</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.CompilerSettingsImpl#isIsTargetCompiler <em>Is Target Compiler</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CompilerSettingsImpl#isIsTargetCompilerOverrideValues <em>Is Target Compiler Override Values</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CompilerSettingsImpl#getType <em>Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CompilerSettingsImpl#getVersion <em>Version</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CompilerSettingsImpl#getPath <em>Path</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CompilerSettingsImpl#getArgs <em>Args</em>}</li>
 * </ul>
 *
 * @generated
 */
public class CompilerSettingsImpl extends MinimalEObjectImpl.Container implements CompilerSettings {
	/**
	 * The default value of the '{@link #isIsTargetCompiler() <em>Is Target Compiler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsTargetCompiler()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_TARGET_COMPILER_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsTargetCompiler() <em>Is Target Compiler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsTargetCompiler()
	 * @generated
	 * @ordered
	 */
	protected boolean isTargetCompiler = IS_TARGET_COMPILER_EDEFAULT;

	/**
	 * The default value of the '{@link #isIsTargetCompilerOverrideValues() <em>Is Target Compiler Override Values</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsTargetCompilerOverrideValues()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_TARGET_COMPILER_OVERRIDE_VALUES_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsTargetCompilerOverrideValues() <em>Is Target Compiler Override Values</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsTargetCompilerOverrideValues()
	 * @generated
	 * @ordered
	 */
	protected boolean isTargetCompilerOverrideValues = IS_TARGET_COMPILER_OVERRIDE_VALUES_EDEFAULT;

	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final String TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected String type = TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getVersion() <em>Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVersion()
	 * @generated
	 * @ordered
	 */
	protected static final String VERSION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getVersion() <em>Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVersion()
	 * @generated
	 * @ordered
	 */
	protected String version = VERSION_EDEFAULT;

	/**
	 * The default value of the '{@link #getPath() <em>Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPath()
	 * @generated
	 * @ordered
	 */
	protected static final String PATH_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getPath() <em>Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPath()
	 * @generated
	 * @ordered
	 */
	protected String path = PATH_EDEFAULT;

	/**
	 * The default value of the '{@link #getArgs() <em>Args</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getArgs()
	 * @generated
	 * @ordered
	 */
	protected static final String ARGS_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getArgs() <em>Args</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getArgs()
	 * @generated
	 * @ordered
	 */
	protected String args = ARGS_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CompilerSettingsImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getCompilerSettings();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsTargetCompiler() {
		return isTargetCompiler;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsTargetCompiler(boolean newIsTargetCompiler) {
		boolean oldIsTargetCompiler = isTargetCompiler;
		isTargetCompiler = newIsTargetCompiler;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.COMPILER_SETTINGS__IS_TARGET_COMPILER, oldIsTargetCompiler, isTargetCompiler));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsTargetCompilerOverrideValues() {
		return isTargetCompilerOverrideValues;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsTargetCompilerOverrideValues(boolean newIsTargetCompilerOverrideValues) {
		boolean oldIsTargetCompilerOverrideValues = isTargetCompilerOverrideValues;
		isTargetCompilerOverrideValues = newIsTargetCompilerOverrideValues;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.COMPILER_SETTINGS__IS_TARGET_COMPILER_OVERRIDE_VALUES, oldIsTargetCompilerOverrideValues, isTargetCompilerOverrideValues));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(String newType) {
		String oldType = type;
		type = newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.COMPILER_SETTINGS__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getVersion() {
		return version;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVersion(String newVersion) {
		String oldVersion = version;
		version = newVersion;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.COMPILER_SETTINGS__VERSION, oldVersion, version));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getPath() {
		return path;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPath(String newPath) {
		String oldPath = path;
		path = newPath;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.COMPILER_SETTINGS__PATH, oldPath, path));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getArgs() {
		return args;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setArgs(String newArgs) {
		String oldArgs = args;
		args = newArgs;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.COMPILER_SETTINGS__ARGS, oldArgs, args));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.COMPILER_SETTINGS__IS_TARGET_COMPILER:
				return isIsTargetCompiler();
			case ModelPackage.COMPILER_SETTINGS__IS_TARGET_COMPILER_OVERRIDE_VALUES:
				return isIsTargetCompilerOverrideValues();
			case ModelPackage.COMPILER_SETTINGS__TYPE:
				return getType();
			case ModelPackage.COMPILER_SETTINGS__VERSION:
				return getVersion();
			case ModelPackage.COMPILER_SETTINGS__PATH:
				return getPath();
			case ModelPackage.COMPILER_SETTINGS__ARGS:
				return getArgs();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.COMPILER_SETTINGS__IS_TARGET_COMPILER:
				setIsTargetCompiler((Boolean)newValue);
				return;
			case ModelPackage.COMPILER_SETTINGS__IS_TARGET_COMPILER_OVERRIDE_VALUES:
				setIsTargetCompilerOverrideValues((Boolean)newValue);
				return;
			case ModelPackage.COMPILER_SETTINGS__TYPE:
				setType((String)newValue);
				return;
			case ModelPackage.COMPILER_SETTINGS__VERSION:
				setVersion((String)newValue);
				return;
			case ModelPackage.COMPILER_SETTINGS__PATH:
				setPath((String)newValue);
				return;
			case ModelPackage.COMPILER_SETTINGS__ARGS:
				setArgs((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.COMPILER_SETTINGS__IS_TARGET_COMPILER:
				setIsTargetCompiler(IS_TARGET_COMPILER_EDEFAULT);
				return;
			case ModelPackage.COMPILER_SETTINGS__IS_TARGET_COMPILER_OVERRIDE_VALUES:
				setIsTargetCompilerOverrideValues(IS_TARGET_COMPILER_OVERRIDE_VALUES_EDEFAULT);
				return;
			case ModelPackage.COMPILER_SETTINGS__TYPE:
				setType(TYPE_EDEFAULT);
				return;
			case ModelPackage.COMPILER_SETTINGS__VERSION:
				setVersion(VERSION_EDEFAULT);
				return;
			case ModelPackage.COMPILER_SETTINGS__PATH:
				setPath(PATH_EDEFAULT);
				return;
			case ModelPackage.COMPILER_SETTINGS__ARGS:
				setArgs(ARGS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.COMPILER_SETTINGS__IS_TARGET_COMPILER:
				return isTargetCompiler != IS_TARGET_COMPILER_EDEFAULT;
			case ModelPackage.COMPILER_SETTINGS__IS_TARGET_COMPILER_OVERRIDE_VALUES:
				return isTargetCompilerOverrideValues != IS_TARGET_COMPILER_OVERRIDE_VALUES_EDEFAULT;
			case ModelPackage.COMPILER_SETTINGS__TYPE:
				return TYPE_EDEFAULT == null ? type != null : !TYPE_EDEFAULT.equals(type);
			case ModelPackage.COMPILER_SETTINGS__VERSION:
				return VERSION_EDEFAULT == null ? version != null : !VERSION_EDEFAULT.equals(version);
			case ModelPackage.COMPILER_SETTINGS__PATH:
				return PATH_EDEFAULT == null ? path != null : !PATH_EDEFAULT.equals(path);
			case ModelPackage.COMPILER_SETTINGS__ARGS:
				return ARGS_EDEFAULT == null ? args != null : !ARGS_EDEFAULT.equals(args);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (isTargetCompiler: ");
		result.append(isTargetCompiler);
		result.append(", isTargetCompilerOverrideValues: ");
		result.append(isTargetCompilerOverrideValues);
		result.append(", type: ");
		result.append(type);
		result.append(", version: ");
		result.append(version);
		result.append(", path: ");
		result.append(path);
		result.append(", args: ");
		result.append(args);
		result.append(')');
		return result.toString();
	}

} //CompilerSettingsImpl
