/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.ConditionalTraceEvent;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.TraceEvent;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Conditional Trace Event</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.ConditionalTraceEventImpl#getTraceEvent <em>Trace Event</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ConditionalTraceEventImpl#getProcess <em>Process</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ConditionalTraceEventImpl#getValueConstraint <em>Value Constraint</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ConditionalTraceEventImpl extends EventChainStepImpl implements ConditionalTraceEvent {
	/**
	 * The cached value of the '{@link #getTraceEvent() <em>Trace Event</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTraceEvent()
	 * @generated
	 * @ordered
	 */
	protected TraceEvent traceEvent;

	/**
	 * The cached value of the '{@link #getProcess() <em>Process</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProcess()
	 * @generated
	 * @ordered
	 */
	protected com.inchron.realtime.root.model.Process process;

	/**
	 * The default value of the '{@link #getValueConstraint() <em>Value Constraint</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getValueConstraint()
	 * @generated
	 * @ordered
	 */
	protected static final String VALUE_CONSTRAINT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getValueConstraint() <em>Value Constraint</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getValueConstraint()
	 * @generated
	 * @ordered
	 */
	protected String valueConstraint = VALUE_CONSTRAINT_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConditionalTraceEventImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getConditionalTraceEvent();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent getTraceEvent() {
		if (traceEvent != null && traceEvent.eIsProxy()) {
			InternalEObject oldTraceEvent = (InternalEObject)traceEvent;
			traceEvent = (TraceEvent)eResolveProxy(oldTraceEvent);
			if (traceEvent != oldTraceEvent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.CONDITIONAL_TRACE_EVENT__TRACE_EVENT, oldTraceEvent, traceEvent));
			}
		}
		return traceEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent basicGetTraceEvent() {
		return traceEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTraceEvent(TraceEvent newTraceEvent) {
		TraceEvent oldTraceEvent = traceEvent;
		traceEvent = newTraceEvent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CONDITIONAL_TRACE_EVENT__TRACE_EVENT, oldTraceEvent, traceEvent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.Process getProcess() {
		if (process != null && process.eIsProxy()) {
			InternalEObject oldProcess = (InternalEObject)process;
			process = (com.inchron.realtime.root.model.Process)eResolveProxy(oldProcess);
			if (process != oldProcess) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.CONDITIONAL_TRACE_EVENT__PROCESS, oldProcess, process));
			}
		}
		return process;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.Process basicGetProcess() {
		return process;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProcess(com.inchron.realtime.root.model.Process newProcess) {
		com.inchron.realtime.root.model.Process oldProcess = process;
		process = newProcess;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CONDITIONAL_TRACE_EVENT__PROCESS, oldProcess, process));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getValueConstraint() {
		return valueConstraint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setValueConstraint(String newValueConstraint) {
		String oldValueConstraint = valueConstraint;
		valueConstraint = newValueConstraint;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CONDITIONAL_TRACE_EVENT__VALUE_CONSTRAINT, oldValueConstraint, valueConstraint));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.CONDITIONAL_TRACE_EVENT__TRACE_EVENT:
				if (resolve) return getTraceEvent();
				return basicGetTraceEvent();
			case ModelPackage.CONDITIONAL_TRACE_EVENT__PROCESS:
				if (resolve) return getProcess();
				return basicGetProcess();
			case ModelPackage.CONDITIONAL_TRACE_EVENT__VALUE_CONSTRAINT:
				return getValueConstraint();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.CONDITIONAL_TRACE_EVENT__TRACE_EVENT:
				setTraceEvent((TraceEvent)newValue);
				return;
			case ModelPackage.CONDITIONAL_TRACE_EVENT__PROCESS:
				setProcess((com.inchron.realtime.root.model.Process)newValue);
				return;
			case ModelPackage.CONDITIONAL_TRACE_EVENT__VALUE_CONSTRAINT:
				setValueConstraint((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.CONDITIONAL_TRACE_EVENT__TRACE_EVENT:
				setTraceEvent((TraceEvent)null);
				return;
			case ModelPackage.CONDITIONAL_TRACE_EVENT__PROCESS:
				setProcess((com.inchron.realtime.root.model.Process)null);
				return;
			case ModelPackage.CONDITIONAL_TRACE_EVENT__VALUE_CONSTRAINT:
				setValueConstraint(VALUE_CONSTRAINT_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.CONDITIONAL_TRACE_EVENT__TRACE_EVENT:
				return traceEvent != null;
			case ModelPackage.CONDITIONAL_TRACE_EVENT__PROCESS:
				return process != null;
			case ModelPackage.CONDITIONAL_TRACE_EVENT__VALUE_CONSTRAINT:
				return VALUE_CONSTRAINT_EDEFAULT == null ? valueConstraint != null : !VALUE_CONSTRAINT_EDEFAULT.equals(valueConstraint);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (valueConstraint: ");
		result.append(valueConstraint);
		result.append(')');
		return result.toString();
	}

} //ConditionalTraceEventImpl
