/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.Clock;
import com.inchron.realtime.root.model.ClockUser;
import com.inchron.realtime.root.model.Cpu;
import com.inchron.realtime.root.model.CpuCore;
import com.inchron.realtime.root.model.HyperVisorConfig;
import com.inchron.realtime.root.model.LoadResource;
import com.inchron.realtime.root.model.MemoryRegion;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.Partition;
import com.inchron.realtime.root.model.TraceObject;

import com.inchron.realtime.root.model.memory.Interconnect;
import com.inchron.realtime.root.model.memory.Memory;

import com.inchron.realtime.root.model.peripheral.Peripheral;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Cpu</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.CpuImpl#getObjectId <em>Object Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CpuImpl#getClock <em>Clock</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CpuImpl#getCores <em>Cores</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CpuImpl#getCpuModel <em>Cpu Model</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CpuImpl#isReloadCpuModel <em>Reload Cpu Model</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CpuImpl#getHypervisor <em>Hypervisor</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CpuImpl#getInterconnects <em>Interconnects</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CpuImpl#getMemories <em>Memories</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CpuImpl#getMemoryRegions <em>Memory Regions</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CpuImpl#getPartitions <em>Partitions</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CpuImpl#getPeripherals <em>Peripherals</em>}</li>
 * </ul>
 *
 * @generated
 */
public class CpuImpl extends ModelObjectImpl implements Cpu {
	/**
	 * The default value of the '{@link #getObjectId() <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectId()
	 * @generated
	 * @ordered
	 */
	protected static final int OBJECT_ID_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getObjectId() <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectId()
	 * @generated
	 * @ordered
	 */
	protected int objectId = OBJECT_ID_EDEFAULT;

	/**
	 * This is true if the Object Id attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean objectIdESet;

	/**
	 * The cached value of the '{@link #getClock() <em>Clock</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getClock()
	 * @generated
	 * @ordered
	 */
	protected Clock clock;

	/**
	 * The cached value of the '{@link #getCores() <em>Cores</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCores()
	 * @generated
	 * @ordered
	 */
	protected EList<CpuCore> cores;

	/**
	 * The default value of the '{@link #getCpuModel() <em>Cpu Model</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCpuModel()
	 * @generated
	 * @ordered
	 */
	protected static final String CPU_MODEL_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getCpuModel() <em>Cpu Model</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCpuModel()
	 * @generated
	 * @ordered
	 */
	protected String cpuModel = CPU_MODEL_EDEFAULT;

	/**
	 * The default value of the '{@link #isReloadCpuModel() <em>Reload Cpu Model</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isReloadCpuModel()
	 * @generated
	 * @ordered
	 */
	protected static final boolean RELOAD_CPU_MODEL_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isReloadCpuModel() <em>Reload Cpu Model</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isReloadCpuModel()
	 * @generated
	 * @ordered
	 */
	protected boolean reloadCpuModel = RELOAD_CPU_MODEL_EDEFAULT;

	/**
	 * The cached value of the '{@link #getHypervisor() <em>Hypervisor</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHypervisor()
	 * @generated
	 * @ordered
	 */
	protected HyperVisorConfig hypervisor;

	/**
	 * The cached value of the '{@link #getInterconnects() <em>Interconnects</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterconnects()
	 * @generated
	 * @ordered
	 */
	protected EList<Interconnect> interconnects;

	/**
	 * The cached value of the '{@link #getMemories() <em>Memories</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMemories()
	 * @generated
	 * @ordered
	 */
	protected EList<Memory> memories;

	/**
	 * The cached value of the '{@link #getMemoryRegions() <em>Memory Regions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMemoryRegions()
	 * @generated
	 * @ordered
	 */
	protected EList<MemoryRegion> memoryRegions;

	/**
	 * The cached value of the '{@link #getPartitions() <em>Partitions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPartitions()
	 * @generated
	 * @ordered
	 */
	protected EList<Partition> partitions;

	/**
	 * The cached value of the '{@link #getPeripherals() <em>Peripherals</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPeripherals()
	 * @generated
	 * @ordered
	 */
	protected EList<Peripheral> peripherals;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CpuImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getCpu();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getObjectId() {
		return objectId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setObjectId(int newObjectId) {
		int oldObjectId = objectId;
		objectId = newObjectId;
		boolean oldObjectIdESet = objectIdESet;
		objectIdESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CPU__OBJECT_ID, oldObjectId, objectId, !oldObjectIdESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetObjectId() {
		int oldObjectId = objectId;
		boolean oldObjectIdESet = objectIdESet;
		objectId = OBJECT_ID_EDEFAULT;
		objectIdESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, ModelPackage.CPU__OBJECT_ID, oldObjectId, OBJECT_ID_EDEFAULT, oldObjectIdESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetObjectId() {
		return objectIdESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Clock getClock() {
		if (clock != null && clock.eIsProxy()) {
			InternalEObject oldClock = (InternalEObject)clock;
			clock = (Clock)eResolveProxy(oldClock);
			if (clock != oldClock) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.CPU__CLOCK, oldClock, clock));
			}
		}
		return clock;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Clock basicGetClock() {
		return clock;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetClock(Clock newClock, NotificationChain msgs) {
		Clock oldClock = clock;
		clock = newClock;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.CPU__CLOCK, oldClock, newClock);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setClock(Clock newClock) {
		if (newClock != clock) {
			NotificationChain msgs = null;
			if (clock != null)
				msgs = ((InternalEObject)clock).eInverseRemove(this, ModelPackage.CLOCK__USERS, Clock.class, msgs);
			if (newClock != null)
				msgs = ((InternalEObject)newClock).eInverseAdd(this, ModelPackage.CLOCK__USERS, Clock.class, msgs);
			msgs = basicSetClock(newClock, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CPU__CLOCK, newClock, newClock));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<CpuCore> getCores() {
		if (cores == null) {
			cores = new EObjectContainmentEList<CpuCore>(CpuCore.class, this, ModelPackage.CPU__CORES);
		}
		return cores;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getCpuModel() {
		return cpuModel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCpuModel(String newCpuModel) {
		String oldCpuModel = cpuModel;
		cpuModel = newCpuModel;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CPU__CPU_MODEL, oldCpuModel, cpuModel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isReloadCpuModel() {
		return reloadCpuModel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setReloadCpuModel(boolean newReloadCpuModel) {
		boolean oldReloadCpuModel = reloadCpuModel;
		reloadCpuModel = newReloadCpuModel;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CPU__RELOAD_CPU_MODEL, oldReloadCpuModel, reloadCpuModel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyperVisorConfig getHypervisor() {
		return hypervisor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetHypervisor(HyperVisorConfig newHypervisor, NotificationChain msgs) {
		HyperVisorConfig oldHypervisor = hypervisor;
		hypervisor = newHypervisor;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.CPU__HYPERVISOR, oldHypervisor, newHypervisor);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHypervisor(HyperVisorConfig newHypervisor) {
		if (newHypervisor != hypervisor) {
			NotificationChain msgs = null;
			if (hypervisor != null)
				msgs = ((InternalEObject)hypervisor).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CPU__HYPERVISOR, null, msgs);
			if (newHypervisor != null)
				msgs = ((InternalEObject)newHypervisor).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.CPU__HYPERVISOR, null, msgs);
			msgs = basicSetHypervisor(newHypervisor, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CPU__HYPERVISOR, newHypervisor, newHypervisor));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Interconnect> getInterconnects() {
		if (interconnects == null) {
			interconnects = new EObjectContainmentEList<Interconnect>(Interconnect.class, this, ModelPackage.CPU__INTERCONNECTS);
		}
		return interconnects;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Memory> getMemories() {
		if (memories == null) {
			memories = new EObjectContainmentEList<Memory>(Memory.class, this, ModelPackage.CPU__MEMORIES);
		}
		return memories;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MemoryRegion> getMemoryRegions() {
		if (memoryRegions == null) {
			memoryRegions = new EObjectContainmentEList<MemoryRegion>(MemoryRegion.class, this, ModelPackage.CPU__MEMORY_REGIONS);
		}
		return memoryRegions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Partition> getPartitions() {
		if (partitions == null) {
			partitions = new EObjectContainmentEList<Partition>(Partition.class, this, ModelPackage.CPU__PARTITIONS);
		}
		return partitions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Peripheral> getPeripherals() {
		if (peripherals == null) {
			peripherals = new EObjectContainmentEList<Peripheral>(Peripheral.class, this, ModelPackage.CPU__PERIPHERALS);
		}
		return peripherals;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.CPU__CLOCK:
				if (clock != null)
					msgs = ((InternalEObject)clock).eInverseRemove(this, ModelPackage.CLOCK__USERS, Clock.class, msgs);
				return basicSetClock((Clock)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.CPU__CLOCK:
				return basicSetClock(null, msgs);
			case ModelPackage.CPU__CORES:
				return ((InternalEList<?>)getCores()).basicRemove(otherEnd, msgs);
			case ModelPackage.CPU__HYPERVISOR:
				return basicSetHypervisor(null, msgs);
			case ModelPackage.CPU__INTERCONNECTS:
				return ((InternalEList<?>)getInterconnects()).basicRemove(otherEnd, msgs);
			case ModelPackage.CPU__MEMORIES:
				return ((InternalEList<?>)getMemories()).basicRemove(otherEnd, msgs);
			case ModelPackage.CPU__MEMORY_REGIONS:
				return ((InternalEList<?>)getMemoryRegions()).basicRemove(otherEnd, msgs);
			case ModelPackage.CPU__PARTITIONS:
				return ((InternalEList<?>)getPartitions()).basicRemove(otherEnd, msgs);
			case ModelPackage.CPU__PERIPHERALS:
				return ((InternalEList<?>)getPeripherals()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.CPU__OBJECT_ID:
				return getObjectId();
			case ModelPackage.CPU__CLOCK:
				if (resolve) return getClock();
				return basicGetClock();
			case ModelPackage.CPU__CORES:
				return getCores();
			case ModelPackage.CPU__CPU_MODEL:
				return getCpuModel();
			case ModelPackage.CPU__RELOAD_CPU_MODEL:
				return isReloadCpuModel();
			case ModelPackage.CPU__HYPERVISOR:
				return getHypervisor();
			case ModelPackage.CPU__INTERCONNECTS:
				return getInterconnects();
			case ModelPackage.CPU__MEMORIES:
				return getMemories();
			case ModelPackage.CPU__MEMORY_REGIONS:
				return getMemoryRegions();
			case ModelPackage.CPU__PARTITIONS:
				return getPartitions();
			case ModelPackage.CPU__PERIPHERALS:
				return getPeripherals();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.CPU__OBJECT_ID:
				setObjectId((Integer)newValue);
				return;
			case ModelPackage.CPU__CLOCK:
				setClock((Clock)newValue);
				return;
			case ModelPackage.CPU__CORES:
				getCores().clear();
				getCores().addAll((Collection<? extends CpuCore>)newValue);
				return;
			case ModelPackage.CPU__CPU_MODEL:
				setCpuModel((String)newValue);
				return;
			case ModelPackage.CPU__RELOAD_CPU_MODEL:
				setReloadCpuModel((Boolean)newValue);
				return;
			case ModelPackage.CPU__HYPERVISOR:
				setHypervisor((HyperVisorConfig)newValue);
				return;
			case ModelPackage.CPU__INTERCONNECTS:
				getInterconnects().clear();
				getInterconnects().addAll((Collection<? extends Interconnect>)newValue);
				return;
			case ModelPackage.CPU__MEMORIES:
				getMemories().clear();
				getMemories().addAll((Collection<? extends Memory>)newValue);
				return;
			case ModelPackage.CPU__MEMORY_REGIONS:
				getMemoryRegions().clear();
				getMemoryRegions().addAll((Collection<? extends MemoryRegion>)newValue);
				return;
			case ModelPackage.CPU__PARTITIONS:
				getPartitions().clear();
				getPartitions().addAll((Collection<? extends Partition>)newValue);
				return;
			case ModelPackage.CPU__PERIPHERALS:
				getPeripherals().clear();
				getPeripherals().addAll((Collection<? extends Peripheral>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.CPU__OBJECT_ID:
				unsetObjectId();
				return;
			case ModelPackage.CPU__CLOCK:
				setClock((Clock)null);
				return;
			case ModelPackage.CPU__CORES:
				getCores().clear();
				return;
			case ModelPackage.CPU__CPU_MODEL:
				setCpuModel(CPU_MODEL_EDEFAULT);
				return;
			case ModelPackage.CPU__RELOAD_CPU_MODEL:
				setReloadCpuModel(RELOAD_CPU_MODEL_EDEFAULT);
				return;
			case ModelPackage.CPU__HYPERVISOR:
				setHypervisor((HyperVisorConfig)null);
				return;
			case ModelPackage.CPU__INTERCONNECTS:
				getInterconnects().clear();
				return;
			case ModelPackage.CPU__MEMORIES:
				getMemories().clear();
				return;
			case ModelPackage.CPU__MEMORY_REGIONS:
				getMemoryRegions().clear();
				return;
			case ModelPackage.CPU__PARTITIONS:
				getPartitions().clear();
				return;
			case ModelPackage.CPU__PERIPHERALS:
				getPeripherals().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.CPU__OBJECT_ID:
				return isSetObjectId();
			case ModelPackage.CPU__CLOCK:
				return clock != null;
			case ModelPackage.CPU__CORES:
				return cores != null && !cores.isEmpty();
			case ModelPackage.CPU__CPU_MODEL:
				return CPU_MODEL_EDEFAULT == null ? cpuModel != null : !CPU_MODEL_EDEFAULT.equals(cpuModel);
			case ModelPackage.CPU__RELOAD_CPU_MODEL:
				return reloadCpuModel != RELOAD_CPU_MODEL_EDEFAULT;
			case ModelPackage.CPU__HYPERVISOR:
				return hypervisor != null;
			case ModelPackage.CPU__INTERCONNECTS:
				return interconnects != null && !interconnects.isEmpty();
			case ModelPackage.CPU__MEMORIES:
				return memories != null && !memories.isEmpty();
			case ModelPackage.CPU__MEMORY_REGIONS:
				return memoryRegions != null && !memoryRegions.isEmpty();
			case ModelPackage.CPU__PARTITIONS:
				return partitions != null && !partitions.isEmpty();
			case ModelPackage.CPU__PERIPHERALS:
				return peripherals != null && !peripherals.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == TraceObject.class) {
			switch (derivedFeatureID) {
				case ModelPackage.CPU__OBJECT_ID: return ModelPackage.TRACE_OBJECT__OBJECT_ID;
				default: return -1;
			}
		}
		if (baseClass == LoadResource.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ClockUser.class) {
			switch (derivedFeatureID) {
				case ModelPackage.CPU__CLOCK: return ModelPackage.CLOCK_USER__CLOCK;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == TraceObject.class) {
			switch (baseFeatureID) {
				case ModelPackage.TRACE_OBJECT__OBJECT_ID: return ModelPackage.CPU__OBJECT_ID;
				default: return -1;
			}
		}
		if (baseClass == LoadResource.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ClockUser.class) {
			switch (baseFeatureID) {
				case ModelPackage.CLOCK_USER__CLOCK: return ModelPackage.CPU__CLOCK;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (objectId: ");
		if (objectIdESet) result.append(objectId); else result.append("<unset>");
		result.append(", cpuModel: ");
		result.append(cpuModel);
		result.append(", reloadCpuModel: ");
		result.append(reloadCpuModel);
		result.append(')');
		return result.toString();
	}

} //CpuImpl
