/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.DataFlowCommunicationType;
import com.inchron.realtime.root.model.DataFlowConnection;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.VariableReadAccess;
import com.inchron.realtime.root.model.VariableWriteAccess;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Data Flow Connection</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.DataFlowConnectionImpl#getCommunicationType <em>Communication Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.DataFlowConnectionImpl#getInitialElements <em>Initial Elements</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.DataFlowConnectionImpl#getMaxElements <em>Max Elements</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.DataFlowConnectionImpl#isMultiQueued <em>Multi Queued</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.DataFlowConnectionImpl#getProvider <em>Provider</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.DataFlowConnectionImpl#getRequesters <em>Requesters</em>}</li>
 * </ul>
 *
 * @generated
 */
public class DataFlowConnectionImpl extends ConnectionImpl implements DataFlowConnection {
	/**
	 * The default value of the '{@link #getCommunicationType() <em>Communication Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCommunicationType()
	 * @generated
	 * @ordered
	 */
	protected static final DataFlowCommunicationType COMMUNICATION_TYPE_EDEFAULT = DataFlowCommunicationType.EVENT_BASED;

	/**
	 * The cached value of the '{@link #getCommunicationType() <em>Communication Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCommunicationType()
	 * @generated
	 * @ordered
	 */
	protected DataFlowCommunicationType communicationType = COMMUNICATION_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getInitialElements() <em>Initial Elements</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInitialElements()
	 * @generated
	 * @ordered
	 */
	protected static final int INITIAL_ELEMENTS_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getInitialElements() <em>Initial Elements</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInitialElements()
	 * @generated
	 * @ordered
	 */
	protected int initialElements = INITIAL_ELEMENTS_EDEFAULT;

	/**
	 * The default value of the '{@link #getMaxElements() <em>Max Elements</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxElements()
	 * @generated
	 * @ordered
	 */
	protected static final int MAX_ELEMENTS_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getMaxElements() <em>Max Elements</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxElements()
	 * @generated
	 * @ordered
	 */
	protected int maxElements = MAX_ELEMENTS_EDEFAULT;

	/**
	 * The default value of the '{@link #isMultiQueued() <em>Multi Queued</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isMultiQueued()
	 * @generated
	 * @ordered
	 */
	protected static final boolean MULTI_QUEUED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isMultiQueued() <em>Multi Queued</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isMultiQueued()
	 * @generated
	 * @ordered
	 */
	protected boolean multiQueued = MULTI_QUEUED_EDEFAULT;

	/**
	 * The cached value of the '{@link #getProvider() <em>Provider</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProvider()
	 * @generated
	 * @ordered
	 */
	protected VariableWriteAccess provider;

	/**
	 * The cached value of the '{@link #getRequesters() <em>Requesters</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRequesters()
	 * @generated
	 * @ordered
	 */
	protected EList<VariableReadAccess> requesters;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataFlowConnectionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getDataFlowConnection();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataFlowCommunicationType getCommunicationType() {
		return communicationType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCommunicationType(DataFlowCommunicationType newCommunicationType) {
		DataFlowCommunicationType oldCommunicationType = communicationType;
		communicationType = newCommunicationType == null ? COMMUNICATION_TYPE_EDEFAULT : newCommunicationType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.DATA_FLOW_CONNECTION__COMMUNICATION_TYPE, oldCommunicationType, communicationType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getInitialElements() {
		return initialElements;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInitialElements(int newInitialElements) {
		int oldInitialElements = initialElements;
		initialElements = newInitialElements;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.DATA_FLOW_CONNECTION__INITIAL_ELEMENTS, oldInitialElements, initialElements));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getMaxElements() {
		return maxElements;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaxElements(int newMaxElements) {
		int oldMaxElements = maxElements;
		maxElements = newMaxElements;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.DATA_FLOW_CONNECTION__MAX_ELEMENTS, oldMaxElements, maxElements));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isMultiQueued() {
		return multiQueued;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMultiQueued(boolean newMultiQueued) {
		boolean oldMultiQueued = multiQueued;
		multiQueued = newMultiQueued;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.DATA_FLOW_CONNECTION__MULTI_QUEUED, oldMultiQueued, multiQueued));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VariableWriteAccess getProvider() {
		if (provider != null && provider.eIsProxy()) {
			InternalEObject oldProvider = (InternalEObject)provider;
			provider = (VariableWriteAccess)eResolveProxy(oldProvider);
			if (provider != oldProvider) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.DATA_FLOW_CONNECTION__PROVIDER, oldProvider, provider));
			}
		}
		return provider;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VariableWriteAccess basicGetProvider() {
		return provider;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetProvider(VariableWriteAccess newProvider, NotificationChain msgs) {
		VariableWriteAccess oldProvider = provider;
		provider = newProvider;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.DATA_FLOW_CONNECTION__PROVIDER, oldProvider, newProvider);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProvider(VariableWriteAccess newProvider) {
		if (newProvider != provider) {
			NotificationChain msgs = null;
			if (provider != null)
				msgs = ((InternalEObject)provider).eInverseRemove(this, ModelPackage.VARIABLE_WRITE_ACCESS__CONNECTION, VariableWriteAccess.class, msgs);
			if (newProvider != null)
				msgs = ((InternalEObject)newProvider).eInverseAdd(this, ModelPackage.VARIABLE_WRITE_ACCESS__CONNECTION, VariableWriteAccess.class, msgs);
			msgs = basicSetProvider(newProvider, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.DATA_FLOW_CONNECTION__PROVIDER, newProvider, newProvider));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<VariableReadAccess> getRequesters() {
		if (requesters == null) {
			requesters = new EObjectWithInverseResolvingEList<VariableReadAccess>(VariableReadAccess.class, this, ModelPackage.DATA_FLOW_CONNECTION__REQUESTERS, ModelPackage.VARIABLE_READ_ACCESS__CONNECTION);
		}
		return requesters;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.DATA_FLOW_CONNECTION__PROVIDER:
				if (provider != null)
					msgs = ((InternalEObject)provider).eInverseRemove(this, ModelPackage.VARIABLE_WRITE_ACCESS__CONNECTION, VariableWriteAccess.class, msgs);
				return basicSetProvider((VariableWriteAccess)otherEnd, msgs);
			case ModelPackage.DATA_FLOW_CONNECTION__REQUESTERS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getRequesters()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.DATA_FLOW_CONNECTION__PROVIDER:
				return basicSetProvider(null, msgs);
			case ModelPackage.DATA_FLOW_CONNECTION__REQUESTERS:
				return ((InternalEList<?>)getRequesters()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.DATA_FLOW_CONNECTION__COMMUNICATION_TYPE:
				return getCommunicationType();
			case ModelPackage.DATA_FLOW_CONNECTION__INITIAL_ELEMENTS:
				return getInitialElements();
			case ModelPackage.DATA_FLOW_CONNECTION__MAX_ELEMENTS:
				return getMaxElements();
			case ModelPackage.DATA_FLOW_CONNECTION__MULTI_QUEUED:
				return isMultiQueued();
			case ModelPackage.DATA_FLOW_CONNECTION__PROVIDER:
				if (resolve) return getProvider();
				return basicGetProvider();
			case ModelPackage.DATA_FLOW_CONNECTION__REQUESTERS:
				return getRequesters();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.DATA_FLOW_CONNECTION__COMMUNICATION_TYPE:
				setCommunicationType((DataFlowCommunicationType)newValue);
				return;
			case ModelPackage.DATA_FLOW_CONNECTION__INITIAL_ELEMENTS:
				setInitialElements((Integer)newValue);
				return;
			case ModelPackage.DATA_FLOW_CONNECTION__MAX_ELEMENTS:
				setMaxElements((Integer)newValue);
				return;
			case ModelPackage.DATA_FLOW_CONNECTION__MULTI_QUEUED:
				setMultiQueued((Boolean)newValue);
				return;
			case ModelPackage.DATA_FLOW_CONNECTION__PROVIDER:
				setProvider((VariableWriteAccess)newValue);
				return;
			case ModelPackage.DATA_FLOW_CONNECTION__REQUESTERS:
				getRequesters().clear();
				getRequesters().addAll((Collection<? extends VariableReadAccess>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.DATA_FLOW_CONNECTION__COMMUNICATION_TYPE:
				setCommunicationType(COMMUNICATION_TYPE_EDEFAULT);
				return;
			case ModelPackage.DATA_FLOW_CONNECTION__INITIAL_ELEMENTS:
				setInitialElements(INITIAL_ELEMENTS_EDEFAULT);
				return;
			case ModelPackage.DATA_FLOW_CONNECTION__MAX_ELEMENTS:
				setMaxElements(MAX_ELEMENTS_EDEFAULT);
				return;
			case ModelPackage.DATA_FLOW_CONNECTION__MULTI_QUEUED:
				setMultiQueued(MULTI_QUEUED_EDEFAULT);
				return;
			case ModelPackage.DATA_FLOW_CONNECTION__PROVIDER:
				setProvider((VariableWriteAccess)null);
				return;
			case ModelPackage.DATA_FLOW_CONNECTION__REQUESTERS:
				getRequesters().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.DATA_FLOW_CONNECTION__COMMUNICATION_TYPE:
				return communicationType != COMMUNICATION_TYPE_EDEFAULT;
			case ModelPackage.DATA_FLOW_CONNECTION__INITIAL_ELEMENTS:
				return initialElements != INITIAL_ELEMENTS_EDEFAULT;
			case ModelPackage.DATA_FLOW_CONNECTION__MAX_ELEMENTS:
				return maxElements != MAX_ELEMENTS_EDEFAULT;
			case ModelPackage.DATA_FLOW_CONNECTION__MULTI_QUEUED:
				return multiQueued != MULTI_QUEUED_EDEFAULT;
			case ModelPackage.DATA_FLOW_CONNECTION__PROVIDER:
				return provider != null;
			case ModelPackage.DATA_FLOW_CONNECTION__REQUESTERS:
				return requesters != null && !requesters.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (communicationType: ");
		result.append(communicationType);
		result.append(", initialElements: ");
		result.append(initialElements);
		result.append(", maxElements: ");
		result.append(maxElements);
		result.append(", multiQueued: ");
		result.append(multiQueued);
		result.append(')');
		return result.toString();
	}

} //DataFlowConnectionImpl
