/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.DiscreteDistributionEntry;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.Time;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Discrete Distribution Entry</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.DiscreteDistributionEntryImpl#getCount <em>Count</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.DiscreteDistributionEntryImpl#getExecTime <em>Exec Time</em>}</li>
 * </ul>
 *
 * @generated
 */
public class DiscreteDistributionEntryImpl extends MinimalEObjectImpl.Container implements DiscreteDistributionEntry {
	/**
	 * The default value of the '{@link #getCount() <em>Count</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCount()
	 * @generated
	 * @ordered
	 */
	protected static final long COUNT_EDEFAULT = 1L;

	/**
	 * The cached value of the '{@link #getCount() <em>Count</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCount()
	 * @generated
	 * @ordered
	 */
	protected long count = COUNT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getExecTime() <em>Exec Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExecTime()
	 * @generated
	 * @ordered
	 */
	protected Time execTime;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DiscreteDistributionEntryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getDiscreteDistributionEntry();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getCount() {
		return count;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCount(long newCount) {
		long oldCount = count;
		count = newCount;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__COUNT, oldCount, count));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getExecTime() {
		return execTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetExecTime(Time newExecTime, NotificationChain msgs) {
		Time oldExecTime = execTime;
		execTime = newExecTime;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__EXEC_TIME, oldExecTime, newExecTime);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExecTime(Time newExecTime) {
		if (newExecTime != execTime) {
			NotificationChain msgs = null;
			if (execTime != null)
				msgs = ((InternalEObject)execTime).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__EXEC_TIME, null, msgs);
			if (newExecTime != null)
				msgs = ((InternalEObject)newExecTime).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__EXEC_TIME, null, msgs);
			msgs = basicSetExecTime(newExecTime, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__EXEC_TIME, newExecTime, newExecTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__EXEC_TIME:
				return basicSetExecTime(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__COUNT:
				return getCount();
			case ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__EXEC_TIME:
				return getExecTime();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__COUNT:
				setCount((Long)newValue);
				return;
			case ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__EXEC_TIME:
				setExecTime((Time)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__COUNT:
				setCount(COUNT_EDEFAULT);
				return;
			case ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__EXEC_TIME:
				setExecTime((Time)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__COUNT:
				return count != COUNT_EDEFAULT;
			case ModelPackage.DISCRETE_DISTRIBUTION_ENTRY__EXEC_TIME:
				return execTime != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (count: ");
		result.append(count);
		result.append(')');
		return result.toString();
	}

} //DiscreteDistributionEntryImpl
