/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.CpuCore;
import com.inchron.realtime.root.model.HyperVisorConfig;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.Scheduler;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hyper Visor Config</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.HyperVisorConfigImpl#getHyperVisorSystem <em>Hyper Visor System</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.HyperVisorConfigImpl#getVmSchedulers <em>Vm Schedulers</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.HyperVisorConfigImpl#getVirtualCores <em>Virtual Cores</em>}</li>
 * </ul>
 *
 * @generated
 */
public class HyperVisorConfigImpl extends ModelObjectImpl implements HyperVisorConfig {
	/**
	 * The cached value of the '{@link #getHyperVisorSystem() <em>Hyper Visor System</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHyperVisorSystem()
	 * @generated
	 * @ordered
	 */
	protected com.inchron.realtime.root.model.System hyperVisorSystem;

	/**
	 * The cached value of the '{@link #getVmSchedulers() <em>Vm Schedulers</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVmSchedulers()
	 * @generated
	 * @ordered
	 */
	protected EList<Scheduler> vmSchedulers;

	/**
	 * The cached value of the '{@link #getVirtualCores() <em>Virtual Cores</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVirtualCores()
	 * @generated
	 * @ordered
	 */
	protected EList<CpuCore> virtualCores;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HyperVisorConfigImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getHyperVisorConfig();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.System getHyperVisorSystem() {
		if (hyperVisorSystem != null && hyperVisorSystem.eIsProxy()) {
			InternalEObject oldHyperVisorSystem = (InternalEObject)hyperVisorSystem;
			hyperVisorSystem = (com.inchron.realtime.root.model.System)eResolveProxy(oldHyperVisorSystem);
			if (hyperVisorSystem != oldHyperVisorSystem) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.HYPER_VISOR_CONFIG__HYPER_VISOR_SYSTEM, oldHyperVisorSystem, hyperVisorSystem));
			}
		}
		return hyperVisorSystem;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.System basicGetHyperVisorSystem() {
		return hyperVisorSystem;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHyperVisorSystem(com.inchron.realtime.root.model.System newHyperVisorSystem) {
		com.inchron.realtime.root.model.System oldHyperVisorSystem = hyperVisorSystem;
		hyperVisorSystem = newHyperVisorSystem;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.HYPER_VISOR_CONFIG__HYPER_VISOR_SYSTEM, oldHyperVisorSystem, hyperVisorSystem));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Scheduler> getVmSchedulers() {
		if (vmSchedulers == null) {
			vmSchedulers = new EObjectContainmentEList<Scheduler>(Scheduler.class, this, ModelPackage.HYPER_VISOR_CONFIG__VM_SCHEDULERS);
		}
		return vmSchedulers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<CpuCore> getVirtualCores() {
		if (virtualCores == null) {
			virtualCores = new EObjectContainmentEList<CpuCore>(CpuCore.class, this, ModelPackage.HYPER_VISOR_CONFIG__VIRTUAL_CORES);
		}
		return virtualCores;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.HYPER_VISOR_CONFIG__VM_SCHEDULERS:
				return ((InternalEList<?>)getVmSchedulers()).basicRemove(otherEnd, msgs);
			case ModelPackage.HYPER_VISOR_CONFIG__VIRTUAL_CORES:
				return ((InternalEList<?>)getVirtualCores()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.HYPER_VISOR_CONFIG__HYPER_VISOR_SYSTEM:
				if (resolve) return getHyperVisorSystem();
				return basicGetHyperVisorSystem();
			case ModelPackage.HYPER_VISOR_CONFIG__VM_SCHEDULERS:
				return getVmSchedulers();
			case ModelPackage.HYPER_VISOR_CONFIG__VIRTUAL_CORES:
				return getVirtualCores();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.HYPER_VISOR_CONFIG__HYPER_VISOR_SYSTEM:
				setHyperVisorSystem((com.inchron.realtime.root.model.System)newValue);
				return;
			case ModelPackage.HYPER_VISOR_CONFIG__VM_SCHEDULERS:
				getVmSchedulers().clear();
				getVmSchedulers().addAll((Collection<? extends Scheduler>)newValue);
				return;
			case ModelPackage.HYPER_VISOR_CONFIG__VIRTUAL_CORES:
				getVirtualCores().clear();
				getVirtualCores().addAll((Collection<? extends CpuCore>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.HYPER_VISOR_CONFIG__HYPER_VISOR_SYSTEM:
				setHyperVisorSystem((com.inchron.realtime.root.model.System)null);
				return;
			case ModelPackage.HYPER_VISOR_CONFIG__VM_SCHEDULERS:
				getVmSchedulers().clear();
				return;
			case ModelPackage.HYPER_VISOR_CONFIG__VIRTUAL_CORES:
				getVirtualCores().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.HYPER_VISOR_CONFIG__HYPER_VISOR_SYSTEM:
				return hyperVisorSystem != null;
			case ModelPackage.HYPER_VISOR_CONFIG__VM_SCHEDULERS:
				return vmSchedulers != null && !vmSchedulers.isEmpty();
			case ModelPackage.HYPER_VISOR_CONFIG__VIRTUAL_CORES:
				return virtualCores != null && !virtualCores.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //HyperVisorConfigImpl
