/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.FunctionCall;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.SetGuard;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Set Guard</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.SetGuardImpl#getFunctionCall <em>Function Call</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SetGuardImpl extends ActivationActionImpl implements SetGuard {
	/**
	 * The cached value of the '{@link #getFunctionCall() <em>Function Call</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFunctionCall()
	 * @generated
	 * @ordered
	 */
	protected FunctionCall functionCall;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SetGuardImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getSetGuard();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FunctionCall getFunctionCall() {
		if (functionCall != null && functionCall.eIsProxy()) {
			InternalEObject oldFunctionCall = (InternalEObject)functionCall;
			functionCall = (FunctionCall)eResolveProxy(oldFunctionCall);
			if (functionCall != oldFunctionCall) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.SET_GUARD__FUNCTION_CALL, oldFunctionCall, functionCall));
			}
		}
		return functionCall;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FunctionCall basicGetFunctionCall() {
		return functionCall;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFunctionCall(FunctionCall newFunctionCall, NotificationChain msgs) {
		FunctionCall oldFunctionCall = functionCall;
		functionCall = newFunctionCall;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.SET_GUARD__FUNCTION_CALL, oldFunctionCall, newFunctionCall);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFunctionCall(FunctionCall newFunctionCall) {
		if (newFunctionCall != functionCall) {
			NotificationChain msgs = null;
			if (functionCall != null)
				msgs = ((InternalEObject)functionCall).eInverseRemove(this, ModelPackage.FUNCTION_CALL__GUARDS, FunctionCall.class, msgs);
			if (newFunctionCall != null)
				msgs = ((InternalEObject)newFunctionCall).eInverseAdd(this, ModelPackage.FUNCTION_CALL__GUARDS, FunctionCall.class, msgs);
			msgs = basicSetFunctionCall(newFunctionCall, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SET_GUARD__FUNCTION_CALL, newFunctionCall, newFunctionCall));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.SET_GUARD__FUNCTION_CALL:
				if (functionCall != null)
					msgs = ((InternalEObject)functionCall).eInverseRemove(this, ModelPackage.FUNCTION_CALL__GUARDS, FunctionCall.class, msgs);
				return basicSetFunctionCall((FunctionCall)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.SET_GUARD__FUNCTION_CALL:
				return basicSetFunctionCall(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.SET_GUARD__FUNCTION_CALL:
				if (resolve) return getFunctionCall();
				return basicGetFunctionCall();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.SET_GUARD__FUNCTION_CALL:
				setFunctionCall((FunctionCall)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.SET_GUARD__FUNCTION_CALL:
				setFunctionCall((FunctionCall)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.SET_GUARD__FUNCTION_CALL:
				return functionCall != null;
		}
		return super.eIsSet(featureID);
	}

} //SetGuardImpl
