/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.memory.impl;

import com.inchron.realtime.root.model.Time;

import com.inchron.realtime.root.model.impl.TraceObjectImpl;

import com.inchron.realtime.root.model.memory.DataAccess;
import com.inchron.realtime.root.model.memory.DataAccessType;
import com.inchron.realtime.root.model.memory.MemoryPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Data Access</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.DataAccessImpl#getAccessType <em>Access Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.DataAccessImpl#getStartOffset <em>Start Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.DataAccessImpl#getBandwidth <em>Bandwidth</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.DataAccessImpl#isIsAsynchronous <em>Is Asynchronous</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class DataAccessImpl extends TraceObjectImpl implements DataAccess {
	/**
	 * The default value of the '{@link #getAccessType() <em>Access Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAccessType()
	 * @generated
	 * @ordered
	 */
	protected static final DataAccessType ACCESS_TYPE_EDEFAULT = DataAccessType.READ;

	/**
	 * The cached value of the '{@link #getAccessType() <em>Access Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAccessType()
	 * @generated
	 * @ordered
	 */
	protected DataAccessType accessType = ACCESS_TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getStartOffset() <em>Start Offset</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartOffset()
	 * @generated
	 * @ordered
	 */
	protected Time startOffset;

	/**
	 * The default value of the '{@link #getBandwidth() <em>Bandwidth</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBandwidth()
	 * @generated
	 * @ordered
	 */
	protected static final long BANDWIDTH_EDEFAULT = 1000000L;

	/**
	 * The cached value of the '{@link #getBandwidth() <em>Bandwidth</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBandwidth()
	 * @generated
	 * @ordered
	 */
	protected long bandwidth = BANDWIDTH_EDEFAULT;

	/**
	 * The default value of the '{@link #isIsAsynchronous() <em>Is Asynchronous</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsAsynchronous()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_ASYNCHRONOUS_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsAsynchronous() <em>Is Asynchronous</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsAsynchronous()
	 * @generated
	 * @ordered
	 */
	protected boolean isAsynchronous = IS_ASYNCHRONOUS_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataAccessImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MemoryPackage.Literals.DATA_ACCESS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataAccessType getAccessType() {
		return accessType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAccessType(DataAccessType newAccessType) {
		DataAccessType oldAccessType = accessType;
		accessType = newAccessType == null ? ACCESS_TYPE_EDEFAULT : newAccessType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.DATA_ACCESS__ACCESS_TYPE, oldAccessType, accessType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getStartOffset() {
		return startOffset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStartOffset(Time newStartOffset, NotificationChain msgs) {
		Time oldStartOffset = startOffset;
		startOffset = newStartOffset;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MemoryPackage.DATA_ACCESS__START_OFFSET, oldStartOffset, newStartOffset);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartOffset(Time newStartOffset) {
		if (newStartOffset != startOffset) {
			NotificationChain msgs = null;
			if (startOffset != null)
				msgs = ((InternalEObject)startOffset).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MemoryPackage.DATA_ACCESS__START_OFFSET, null, msgs);
			if (newStartOffset != null)
				msgs = ((InternalEObject)newStartOffset).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MemoryPackage.DATA_ACCESS__START_OFFSET, null, msgs);
			msgs = basicSetStartOffset(newStartOffset, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.DATA_ACCESS__START_OFFSET, newStartOffset, newStartOffset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getBandwidth() {
		return bandwidth;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBandwidth(long newBandwidth) {
		long oldBandwidth = bandwidth;
		bandwidth = newBandwidth;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.DATA_ACCESS__BANDWIDTH, oldBandwidth, bandwidth));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsAsynchronous() {
		return isAsynchronous;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsAsynchronous(boolean newIsAsynchronous) {
		boolean oldIsAsynchronous = isAsynchronous;
		isAsynchronous = newIsAsynchronous;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.DATA_ACCESS__IS_ASYNCHRONOUS, oldIsAsynchronous, isAsynchronous));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MemoryPackage.DATA_ACCESS__START_OFFSET:
				return basicSetStartOffset(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MemoryPackage.DATA_ACCESS__ACCESS_TYPE:
				return getAccessType();
			case MemoryPackage.DATA_ACCESS__START_OFFSET:
				return getStartOffset();
			case MemoryPackage.DATA_ACCESS__BANDWIDTH:
				return getBandwidth();
			case MemoryPackage.DATA_ACCESS__IS_ASYNCHRONOUS:
				return isIsAsynchronous();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MemoryPackage.DATA_ACCESS__ACCESS_TYPE:
				setAccessType((DataAccessType)newValue);
				return;
			case MemoryPackage.DATA_ACCESS__START_OFFSET:
				setStartOffset((Time)newValue);
				return;
			case MemoryPackage.DATA_ACCESS__BANDWIDTH:
				setBandwidth((Long)newValue);
				return;
			case MemoryPackage.DATA_ACCESS__IS_ASYNCHRONOUS:
				setIsAsynchronous((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MemoryPackage.DATA_ACCESS__ACCESS_TYPE:
				setAccessType(ACCESS_TYPE_EDEFAULT);
				return;
			case MemoryPackage.DATA_ACCESS__START_OFFSET:
				setStartOffset((Time)null);
				return;
			case MemoryPackage.DATA_ACCESS__BANDWIDTH:
				setBandwidth(BANDWIDTH_EDEFAULT);
				return;
			case MemoryPackage.DATA_ACCESS__IS_ASYNCHRONOUS:
				setIsAsynchronous(IS_ASYNCHRONOUS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MemoryPackage.DATA_ACCESS__ACCESS_TYPE:
				return accessType != ACCESS_TYPE_EDEFAULT;
			case MemoryPackage.DATA_ACCESS__START_OFFSET:
				return startOffset != null;
			case MemoryPackage.DATA_ACCESS__BANDWIDTH:
				return bandwidth != BANDWIDTH_EDEFAULT;
			case MemoryPackage.DATA_ACCESS__IS_ASYNCHRONOUS:
				return isAsynchronous != IS_ASYNCHRONOUS_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (accessType: ");
		result.append(accessType);
		result.append(", bandwidth: ");
		result.append(bandwidth);
		result.append(", isAsynchronous: ");
		result.append(isAsynchronous);
		result.append(')');
		return result.toString();
	}

} //DataAccessImpl
