/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>AS5643</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AS5643#isCC <em>CC</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AS5643#getNodeId <em>Node Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AS5643#getRank <em>Rank</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AS5643#getTransmissionOffset <em>Transmission Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AS5643#getReceiveOffset <em>Receive Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AS5643#getDatapumpOffset <em>Datapump Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AS5643#isMonitorNode <em>Monitor Node</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAS5643()
 * @model
 * @generated
 */
public interface AS5643 extends Peripheral {
	/**
	 * Returns the value of the '<em><b>CC</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>CC</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>CC</em>' attribute.
	 * @see #setCC(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAS5643_CC()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isCC();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AS5643#isCC <em>CC</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>CC</em>' attribute.
	 * @see #isCC()
	 * @generated
	 */
	void setCC(boolean value);

	/**
	 * Returns the value of the '<em><b>Node Id</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Node Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Node Id</em>' attribute.
	 * @see #setNodeId(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAS5643_NodeId()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getNodeId();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AS5643#getNodeId <em>Node Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Node Id</em>' attribute.
	 * @see #getNodeId()
	 * @generated
	 */
	void setNodeId(int value);

	/**
	 * Returns the value of the '<em><b>Rank</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rank</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rank</em>' attribute.
	 * @see #setRank(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAS5643_Rank()
	 * @model default="1" required="true"
	 * @generated
	 */
	int getRank();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AS5643#getRank <em>Rank</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Rank</em>' attribute.
	 * @see #getRank()
	 * @generated
	 */
	void setRank(int value);

	/**
	 * Returns the value of the '<em><b>Transmission Offset</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Transmission Offset</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Transmission Offset</em>' attribute.
	 * @see #setTransmissionOffset(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAS5643_TransmissionOffset()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getTransmissionOffset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AS5643#getTransmissionOffset <em>Transmission Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Transmission Offset</em>' attribute.
	 * @see #getTransmissionOffset()
	 * @generated
	 */
	void setTransmissionOffset(int value);

	/**
	 * Returns the value of the '<em><b>Receive Offset</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Receive Offset</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Receive Offset</em>' attribute.
	 * @see #setReceiveOffset(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAS5643_ReceiveOffset()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getReceiveOffset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AS5643#getReceiveOffset <em>Receive Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Receive Offset</em>' attribute.
	 * @see #getReceiveOffset()
	 * @generated
	 */
	void setReceiveOffset(int value);

	/**
	 * Returns the value of the '<em><b>Datapump Offset</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Datapump Offset</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Datapump Offset</em>' attribute.
	 * @see #setDatapumpOffset(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAS5643_DatapumpOffset()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getDatapumpOffset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AS5643#getDatapumpOffset <em>Datapump Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Datapump Offset</em>' attribute.
	 * @see #getDatapumpOffset()
	 * @generated
	 */
	void setDatapumpOffset(int value);

	/**
	 * Returns the value of the '<em><b>Monitor Node</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Monitor Node</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Monitor Node</em>' attribute.
	 * @see #setMonitorNode(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAS5643_MonitorNode()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isMonitorNode();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AS5643#isMonitorNode <em>Monitor Node</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Monitor Node</em>' attribute.
	 * @see #isMonitorNode()
	 * @generated
	 */
	void setMonitorNode(boolean value);

} // AS5643
