/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;

import com.inchron.realtime.root.model.BufferStrategy;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CAN</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.CAN#getBufferStrategy <em>Buffer Strategy</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.CAN#getNumberOfBuffers <em>Number Of Buffers</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getCAN()
 * @model annotation="http://www.eclipse.org/emf/2002/GenModel name='CAN Communication Controller'"
 * @generated
 */
public interface CAN extends Peripheral {
	/**
	 * Returns the value of the '<em><b>Buffer Strategy</b></em>' attribute.
	 * The default value is <code>"SlotOrder"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.BufferStrategy}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Buffer Strategy</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Buffer Strategy</em>' attribute.
	 * @see com.inchron.realtime.root.model.BufferStrategy
	 * @see #setBufferStrategy(BufferStrategy)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getCAN_BufferStrategy()
	 * @model default="SlotOrder" required="true"
	 * @generated
	 */
	BufferStrategy getBufferStrategy();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.CAN#getBufferStrategy <em>Buffer Strategy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Buffer Strategy</em>' attribute.
	 * @see com.inchron.realtime.root.model.BufferStrategy
	 * @see #getBufferStrategy()
	 * @generated
	 */
	void setBufferStrategy(BufferStrategy value);

	/**
	 * Returns the value of the '<em><b>Number Of Buffers</b></em>' attribute.
	 * The default value is <code>"256"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Number Of Buffers</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Number Of Buffers</em>' attribute.
	 * @see #setNumberOfBuffers(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getCAN_NumberOfBuffers()
	 * @model default="256"
	 * @generated
	 */
	int getNumberOfBuffers();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.CAN#getNumberOfBuffers <em>Number Of Buffers</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Number Of Buffers</em>' attribute.
	 * @see #getNumberOfBuffers()
	 * @generated
	 */
	void setNumberOfBuffers(int value);

} // CAN
