/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Interrupt Port</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.InterruptPort#getIsrs <em>Isrs</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getInterruptPort()
 * @model
 * @generated
 */
public interface InterruptPort extends AbstractPort {
	/**
	 * Returns the value of the '<em><b>Isrs</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Process}.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.Process#getTriggeringPort <em>Triggering Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Isrs</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Isrs</em>' reference list.
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getInterruptPort_Isrs()
	 * @see com.inchron.realtime.root.model.Process#getTriggeringPort
	 * @model opposite="triggeringPort" ordered="false"
	 * @generated
	 */
	EList<com.inchron.realtime.root.model.Process> getIsrs();

} // InterruptPort
