/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.peripheral.AS5643;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>AS5643</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AS5643Impl#isCC <em>CC</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AS5643Impl#getNodeId <em>Node Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AS5643Impl#getRank <em>Rank</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AS5643Impl#getTransmissionOffset <em>Transmission Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AS5643Impl#getReceiveOffset <em>Receive Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AS5643Impl#getDatapumpOffset <em>Datapump Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AS5643Impl#isMonitorNode <em>Monitor Node</em>}</li>
 * </ul>
 *
 * @generated
 */
public class AS5643Impl extends PeripheralImpl implements AS5643 {
	/**
	 * The default value of the '{@link #isCC() <em>CC</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isCC()
	 * @generated
	 * @ordered
	 */
	protected static final boolean CC_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isCC() <em>CC</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isCC()
	 * @generated
	 * @ordered
	 */
	protected boolean cc = CC_EDEFAULT;

	/**
	 * The default value of the '{@link #getNodeId() <em>Node Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNodeId()
	 * @generated
	 * @ordered
	 */
	protected static final int NODE_ID_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getNodeId() <em>Node Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNodeId()
	 * @generated
	 * @ordered
	 */
	protected int nodeId = NODE_ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getRank() <em>Rank</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRank()
	 * @generated
	 * @ordered
	 */
	protected static final int RANK_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getRank() <em>Rank</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRank()
	 * @generated
	 * @ordered
	 */
	protected int rank = RANK_EDEFAULT;

	/**
	 * The default value of the '{@link #getTransmissionOffset() <em>Transmission Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTransmissionOffset()
	 * @generated
	 * @ordered
	 */
	protected static final int TRANSMISSION_OFFSET_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getTransmissionOffset() <em>Transmission Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTransmissionOffset()
	 * @generated
	 * @ordered
	 */
	protected int transmissionOffset = TRANSMISSION_OFFSET_EDEFAULT;

	/**
	 * The default value of the '{@link #getReceiveOffset() <em>Receive Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReceiveOffset()
	 * @generated
	 * @ordered
	 */
	protected static final int RECEIVE_OFFSET_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getReceiveOffset() <em>Receive Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReceiveOffset()
	 * @generated
	 * @ordered
	 */
	protected int receiveOffset = RECEIVE_OFFSET_EDEFAULT;

	/**
	 * The default value of the '{@link #getDatapumpOffset() <em>Datapump Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDatapumpOffset()
	 * @generated
	 * @ordered
	 */
	protected static final int DATAPUMP_OFFSET_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getDatapumpOffset() <em>Datapump Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDatapumpOffset()
	 * @generated
	 * @ordered
	 */
	protected int datapumpOffset = DATAPUMP_OFFSET_EDEFAULT;

	/**
	 * The default value of the '{@link #isMonitorNode() <em>Monitor Node</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isMonitorNode()
	 * @generated
	 * @ordered
	 */
	protected static final boolean MONITOR_NODE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isMonitorNode() <em>Monitor Node</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isMonitorNode()
	 * @generated
	 * @ordered
	 */
	protected boolean monitorNode = MONITOR_NODE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AS5643Impl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PeripheralPackage.Literals.AS5643;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isCC() {
		return cc;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCC(boolean newCC) {
		boolean oldCC = cc;
		cc = newCC;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AS5643__CC, oldCC, cc));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getNodeId() {
		return nodeId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNodeId(int newNodeId) {
		int oldNodeId = nodeId;
		nodeId = newNodeId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AS5643__NODE_ID, oldNodeId, nodeId));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getRank() {
		return rank;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRank(int newRank) {
		int oldRank = rank;
		rank = newRank;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AS5643__RANK, oldRank, rank));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getTransmissionOffset() {
		return transmissionOffset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTransmissionOffset(int newTransmissionOffset) {
		int oldTransmissionOffset = transmissionOffset;
		transmissionOffset = newTransmissionOffset;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AS5643__TRANSMISSION_OFFSET, oldTransmissionOffset, transmissionOffset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getReceiveOffset() {
		return receiveOffset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setReceiveOffset(int newReceiveOffset) {
		int oldReceiveOffset = receiveOffset;
		receiveOffset = newReceiveOffset;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AS5643__RECEIVE_OFFSET, oldReceiveOffset, receiveOffset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getDatapumpOffset() {
		return datapumpOffset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDatapumpOffset(int newDatapumpOffset) {
		int oldDatapumpOffset = datapumpOffset;
		datapumpOffset = newDatapumpOffset;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AS5643__DATAPUMP_OFFSET, oldDatapumpOffset, datapumpOffset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isMonitorNode() {
		return monitorNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMonitorNode(boolean newMonitorNode) {
		boolean oldMonitorNode = monitorNode;
		monitorNode = newMonitorNode;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AS5643__MONITOR_NODE, oldMonitorNode, monitorNode));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PeripheralPackage.AS5643__CC:
				return isCC();
			case PeripheralPackage.AS5643__NODE_ID:
				return getNodeId();
			case PeripheralPackage.AS5643__RANK:
				return getRank();
			case PeripheralPackage.AS5643__TRANSMISSION_OFFSET:
				return getTransmissionOffset();
			case PeripheralPackage.AS5643__RECEIVE_OFFSET:
				return getReceiveOffset();
			case PeripheralPackage.AS5643__DATAPUMP_OFFSET:
				return getDatapumpOffset();
			case PeripheralPackage.AS5643__MONITOR_NODE:
				return isMonitorNode();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PeripheralPackage.AS5643__CC:
				setCC((Boolean)newValue);
				return;
			case PeripheralPackage.AS5643__NODE_ID:
				setNodeId((Integer)newValue);
				return;
			case PeripheralPackage.AS5643__RANK:
				setRank((Integer)newValue);
				return;
			case PeripheralPackage.AS5643__TRANSMISSION_OFFSET:
				setTransmissionOffset((Integer)newValue);
				return;
			case PeripheralPackage.AS5643__RECEIVE_OFFSET:
				setReceiveOffset((Integer)newValue);
				return;
			case PeripheralPackage.AS5643__DATAPUMP_OFFSET:
				setDatapumpOffset((Integer)newValue);
				return;
			case PeripheralPackage.AS5643__MONITOR_NODE:
				setMonitorNode((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PeripheralPackage.AS5643__CC:
				setCC(CC_EDEFAULT);
				return;
			case PeripheralPackage.AS5643__NODE_ID:
				setNodeId(NODE_ID_EDEFAULT);
				return;
			case PeripheralPackage.AS5643__RANK:
				setRank(RANK_EDEFAULT);
				return;
			case PeripheralPackage.AS5643__TRANSMISSION_OFFSET:
				setTransmissionOffset(TRANSMISSION_OFFSET_EDEFAULT);
				return;
			case PeripheralPackage.AS5643__RECEIVE_OFFSET:
				setReceiveOffset(RECEIVE_OFFSET_EDEFAULT);
				return;
			case PeripheralPackage.AS5643__DATAPUMP_OFFSET:
				setDatapumpOffset(DATAPUMP_OFFSET_EDEFAULT);
				return;
			case PeripheralPackage.AS5643__MONITOR_NODE:
				setMonitorNode(MONITOR_NODE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PeripheralPackage.AS5643__CC:
				return cc != CC_EDEFAULT;
			case PeripheralPackage.AS5643__NODE_ID:
				return nodeId != NODE_ID_EDEFAULT;
			case PeripheralPackage.AS5643__RANK:
				return rank != RANK_EDEFAULT;
			case PeripheralPackage.AS5643__TRANSMISSION_OFFSET:
				return transmissionOffset != TRANSMISSION_OFFSET_EDEFAULT;
			case PeripheralPackage.AS5643__RECEIVE_OFFSET:
				return receiveOffset != RECEIVE_OFFSET_EDEFAULT;
			case PeripheralPackage.AS5643__DATAPUMP_OFFSET:
				return datapumpOffset != DATAPUMP_OFFSET_EDEFAULT;
			case PeripheralPackage.AS5643__MONITOR_NODE:
				return monitorNode != MONITOR_NODE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (CC: ");
		result.append(cc);
		result.append(", nodeId: ");
		result.append(nodeId);
		result.append(", rank: ");
		result.append(rank);
		result.append(", transmissionOffset: ");
		result.append(transmissionOffset);
		result.append(", receiveOffset: ");
		result.append(receiveOffset);
		result.append(", datapumpOffset: ");
		result.append(datapumpOffset);
		result.append(", monitorNode: ");
		result.append(monitorNode);
		result.append(')');
		return result.toString();
	}

} //AS5643Impl
