/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.peripheral.AbstractEthernet;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Abstract Ethernet</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AbstractEthernetImpl#isAutoNegotiate <em>Auto Negotiate</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AbstractEthernetImpl#isFullDuplex <em>Full Duplex</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AbstractEthernetImpl#getNumberOfPorts <em>Number Of Ports</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AbstractEthernetImpl#getSpeed <em>Speed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AbstractEthernetImpl#isSupportsQoS <em>Supports Qo S</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class AbstractEthernetImpl extends PeripheralImpl implements AbstractEthernet {
	/**
	 * The default value of the '{@link #isAutoNegotiate() <em>Auto Negotiate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isAutoNegotiate()
	 * @generated
	 * @ordered
	 */
	protected static final boolean AUTO_NEGOTIATE_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isAutoNegotiate() <em>Auto Negotiate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isAutoNegotiate()
	 * @generated
	 * @ordered
	 */
	protected boolean autoNegotiate = AUTO_NEGOTIATE_EDEFAULT;

	/**
	 * The default value of the '{@link #isFullDuplex() <em>Full Duplex</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isFullDuplex()
	 * @generated
	 * @ordered
	 */
	protected static final boolean FULL_DUPLEX_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isFullDuplex() <em>Full Duplex</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isFullDuplex()
	 * @generated
	 * @ordered
	 */
	protected boolean fullDuplex = FULL_DUPLEX_EDEFAULT;

	/**
	 * The default value of the '{@link #getNumberOfPorts() <em>Number Of Ports</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumberOfPorts()
	 * @generated
	 * @ordered
	 */
	protected static final int NUMBER_OF_PORTS_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getNumberOfPorts() <em>Number Of Ports</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumberOfPorts()
	 * @generated
	 * @ordered
	 */
	protected int numberOfPorts = NUMBER_OF_PORTS_EDEFAULT;

	/**
	 * The default value of the '{@link #getSpeed() <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpeed()
	 * @generated
	 * @ordered
	 */
	protected static final int SPEED_EDEFAULT = 100000000;

	/**
	 * The cached value of the '{@link #getSpeed() <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpeed()
	 * @generated
	 * @ordered
	 */
	protected int speed = SPEED_EDEFAULT;

	/**
	 * The default value of the '{@link #isSupportsQoS() <em>Supports Qo S</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSupportsQoS()
	 * @generated
	 * @ordered
	 */
	protected static final boolean SUPPORTS_QO_S_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isSupportsQoS() <em>Supports Qo S</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSupportsQoS()
	 * @generated
	 * @ordered
	 */
	protected boolean supportsQoS = SUPPORTS_QO_S_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AbstractEthernetImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PeripheralPackage.Literals.ABSTRACT_ETHERNET;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isAutoNegotiate() {
		return autoNegotiate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAutoNegotiate(boolean newAutoNegotiate) {
		boolean oldAutoNegotiate = autoNegotiate;
		autoNegotiate = newAutoNegotiate;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.ABSTRACT_ETHERNET__AUTO_NEGOTIATE, oldAutoNegotiate, autoNegotiate));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isFullDuplex() {
		return fullDuplex;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFullDuplex(boolean newFullDuplex) {
		boolean oldFullDuplex = fullDuplex;
		fullDuplex = newFullDuplex;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.ABSTRACT_ETHERNET__FULL_DUPLEX, oldFullDuplex, fullDuplex));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getNumberOfPorts() {
		return numberOfPorts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNumberOfPorts(int newNumberOfPorts) {
		int oldNumberOfPorts = numberOfPorts;
		numberOfPorts = newNumberOfPorts;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.ABSTRACT_ETHERNET__NUMBER_OF_PORTS, oldNumberOfPorts, numberOfPorts));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getSpeed() {
		return speed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSpeed(int newSpeed) {
		int oldSpeed = speed;
		speed = newSpeed;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.ABSTRACT_ETHERNET__SPEED, oldSpeed, speed));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSupportsQoS() {
		return supportsQoS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSupportsQoS(boolean newSupportsQoS) {
		boolean oldSupportsQoS = supportsQoS;
		supportsQoS = newSupportsQoS;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.ABSTRACT_ETHERNET__SUPPORTS_QO_S, oldSupportsQoS, supportsQoS));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PeripheralPackage.ABSTRACT_ETHERNET__AUTO_NEGOTIATE:
				return isAutoNegotiate();
			case PeripheralPackage.ABSTRACT_ETHERNET__FULL_DUPLEX:
				return isFullDuplex();
			case PeripheralPackage.ABSTRACT_ETHERNET__NUMBER_OF_PORTS:
				return getNumberOfPorts();
			case PeripheralPackage.ABSTRACT_ETHERNET__SPEED:
				return getSpeed();
			case PeripheralPackage.ABSTRACT_ETHERNET__SUPPORTS_QO_S:
				return isSupportsQoS();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PeripheralPackage.ABSTRACT_ETHERNET__AUTO_NEGOTIATE:
				setAutoNegotiate((Boolean)newValue);
				return;
			case PeripheralPackage.ABSTRACT_ETHERNET__FULL_DUPLEX:
				setFullDuplex((Boolean)newValue);
				return;
			case PeripheralPackage.ABSTRACT_ETHERNET__NUMBER_OF_PORTS:
				setNumberOfPorts((Integer)newValue);
				return;
			case PeripheralPackage.ABSTRACT_ETHERNET__SPEED:
				setSpeed((Integer)newValue);
				return;
			case PeripheralPackage.ABSTRACT_ETHERNET__SUPPORTS_QO_S:
				setSupportsQoS((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PeripheralPackage.ABSTRACT_ETHERNET__AUTO_NEGOTIATE:
				setAutoNegotiate(AUTO_NEGOTIATE_EDEFAULT);
				return;
			case PeripheralPackage.ABSTRACT_ETHERNET__FULL_DUPLEX:
				setFullDuplex(FULL_DUPLEX_EDEFAULT);
				return;
			case PeripheralPackage.ABSTRACT_ETHERNET__NUMBER_OF_PORTS:
				setNumberOfPorts(NUMBER_OF_PORTS_EDEFAULT);
				return;
			case PeripheralPackage.ABSTRACT_ETHERNET__SPEED:
				setSpeed(SPEED_EDEFAULT);
				return;
			case PeripheralPackage.ABSTRACT_ETHERNET__SUPPORTS_QO_S:
				setSupportsQoS(SUPPORTS_QO_S_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PeripheralPackage.ABSTRACT_ETHERNET__AUTO_NEGOTIATE:
				return autoNegotiate != AUTO_NEGOTIATE_EDEFAULT;
			case PeripheralPackage.ABSTRACT_ETHERNET__FULL_DUPLEX:
				return fullDuplex != FULL_DUPLEX_EDEFAULT;
			case PeripheralPackage.ABSTRACT_ETHERNET__NUMBER_OF_PORTS:
				return numberOfPorts != NUMBER_OF_PORTS_EDEFAULT;
			case PeripheralPackage.ABSTRACT_ETHERNET__SPEED:
				return speed != SPEED_EDEFAULT;
			case PeripheralPackage.ABSTRACT_ETHERNET__SUPPORTS_QO_S:
				return supportsQoS != SUPPORTS_QO_S_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (autoNegotiate: ");
		result.append(autoNegotiate);
		result.append(", fullDuplex: ");
		result.append(fullDuplex);
		result.append(", numberOfPorts: ");
		result.append(numberOfPorts);
		result.append(", speed: ");
		result.append(speed);
		result.append(", supportsQoS: ");
		result.append(supportsQoS);
		result.append(')');
		return result.toString();
	}

} //AbstractEthernetImpl
