/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.TraceEvent;
import com.inchron.realtime.root.model.TraceObject;

import com.inchron.realtime.root.model.impl.ModelObjectImpl;

import com.inchron.realtime.root.model.peripheral.AbstractPeripheral;
import com.inchron.realtime.root.model.peripheral.AbstractPort;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import java.lang.reflect.InvocationTargetException;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Abstract Peripheral</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AbstractPeripheralImpl#getObjectId <em>Object Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AbstractPeripheralImpl#getExactness <em>Exactness</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AbstractPeripheralImpl#getEvents <em>Events</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AbstractPeripheralImpl#getPorts <em>Ports</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class AbstractPeripheralImpl extends ModelObjectImpl implements AbstractPeripheral {
	/**
	 * The default value of the '{@link #getObjectId() <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectId()
	 * @generated
	 * @ordered
	 */
	protected static final int OBJECT_ID_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getObjectId() <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectId()
	 * @generated
	 * @ordered
	 */
	protected int objectId = OBJECT_ID_EDEFAULT;

	/**
	 * This is true if the Object Id attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean objectIdESet;

	/**
	 * The default value of the '{@link #getExactness() <em>Exactness</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExactness()
	 * @generated
	 * @ordered
	 */
	protected static final int EXACTNESS_EDEFAULT = 10;

	/**
	 * The cached value of the '{@link #getExactness() <em>Exactness</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExactness()
	 * @generated
	 * @ordered
	 */
	protected int exactness = EXACTNESS_EDEFAULT;

	/**
	 * The cached value of the '{@link #getEvents() <em>Events</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEvents()
	 * @generated
	 * @ordered
	 */
	protected EList<TraceEvent> events;

	/**
	 * The cached value of the '{@link #getPorts() <em>Ports</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPorts()
	 * @generated
	 * @ordered
	 */
	protected EList<AbstractPort> ports;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AbstractPeripheralImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PeripheralPackage.Literals.ABSTRACT_PERIPHERAL;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getObjectId() {
		return objectId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setObjectId(int newObjectId) {
		int oldObjectId = objectId;
		objectId = newObjectId;
		boolean oldObjectIdESet = objectIdESet;
		objectIdESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.ABSTRACT_PERIPHERAL__OBJECT_ID, oldObjectId, objectId, !oldObjectIdESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetObjectId() {
		int oldObjectId = objectId;
		boolean oldObjectIdESet = objectIdESet;
		objectId = OBJECT_ID_EDEFAULT;
		objectIdESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, PeripheralPackage.ABSTRACT_PERIPHERAL__OBJECT_ID, oldObjectId, OBJECT_ID_EDEFAULT, oldObjectIdESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetObjectId() {
		return objectIdESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getExactness() {
		return exactness;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExactness(int newExactness) {
		int oldExactness = exactness;
		exactness = newExactness;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.ABSTRACT_PERIPHERAL__EXACTNESS, oldExactness, exactness));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<TraceEvent> getEvents() {
		if (events == null) {
			events = new EObjectContainmentEList<TraceEvent>(TraceEvent.class, this, PeripheralPackage.ABSTRACT_PERIPHERAL__EVENTS);
		}
		return events;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<AbstractPort> getPorts() {
		if (ports == null) {
			ports = new EObjectContainmentEList<AbstractPort>(AbstractPort.class, this, PeripheralPackage.ABSTRACT_PERIPHERAL__PORTS);
		}
		return ports;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isCompatible(AbstractPeripheral other) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PeripheralPackage.ABSTRACT_PERIPHERAL__EVENTS:
				return ((InternalEList<?>)getEvents()).basicRemove(otherEnd, msgs);
			case PeripheralPackage.ABSTRACT_PERIPHERAL__PORTS:
				return ((InternalEList<?>)getPorts()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PeripheralPackage.ABSTRACT_PERIPHERAL__OBJECT_ID:
				return getObjectId();
			case PeripheralPackage.ABSTRACT_PERIPHERAL__EXACTNESS:
				return getExactness();
			case PeripheralPackage.ABSTRACT_PERIPHERAL__EVENTS:
				return getEvents();
			case PeripheralPackage.ABSTRACT_PERIPHERAL__PORTS:
				return getPorts();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PeripheralPackage.ABSTRACT_PERIPHERAL__OBJECT_ID:
				setObjectId((Integer)newValue);
				return;
			case PeripheralPackage.ABSTRACT_PERIPHERAL__EXACTNESS:
				setExactness((Integer)newValue);
				return;
			case PeripheralPackage.ABSTRACT_PERIPHERAL__EVENTS:
				getEvents().clear();
				getEvents().addAll((Collection<? extends TraceEvent>)newValue);
				return;
			case PeripheralPackage.ABSTRACT_PERIPHERAL__PORTS:
				getPorts().clear();
				getPorts().addAll((Collection<? extends AbstractPort>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PeripheralPackage.ABSTRACT_PERIPHERAL__OBJECT_ID:
				unsetObjectId();
				return;
			case PeripheralPackage.ABSTRACT_PERIPHERAL__EXACTNESS:
				setExactness(EXACTNESS_EDEFAULT);
				return;
			case PeripheralPackage.ABSTRACT_PERIPHERAL__EVENTS:
				getEvents().clear();
				return;
			case PeripheralPackage.ABSTRACT_PERIPHERAL__PORTS:
				getPorts().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PeripheralPackage.ABSTRACT_PERIPHERAL__OBJECT_ID:
				return isSetObjectId();
			case PeripheralPackage.ABSTRACT_PERIPHERAL__EXACTNESS:
				return exactness != EXACTNESS_EDEFAULT;
			case PeripheralPackage.ABSTRACT_PERIPHERAL__EVENTS:
				return events != null && !events.isEmpty();
			case PeripheralPackage.ABSTRACT_PERIPHERAL__PORTS:
				return ports != null && !ports.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == TraceObject.class) {
			switch (derivedFeatureID) {
				case PeripheralPackage.ABSTRACT_PERIPHERAL__OBJECT_ID: return ModelPackage.TRACE_OBJECT__OBJECT_ID;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == TraceObject.class) {
			switch (baseFeatureID) {
				case ModelPackage.TRACE_OBJECT__OBJECT_ID: return PeripheralPackage.ABSTRACT_PERIPHERAL__OBJECT_ID;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
			case PeripheralPackage.ABSTRACT_PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL:
				return isCompatible((AbstractPeripheral)arguments.get(0));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (objectId: ");
		if (objectIdESet) result.append(objectId); else result.append("<unset>");
		result.append(", exactness: ");
		result.append(exactness);
		result.append(')');
		return result.toString();
	}

} //AbstractPeripheralImpl
