/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.peripheral.CANBus;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>CAN Bus</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.CANBusImpl#isLogEnabled <em>Log Enabled</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.CANBusImpl#getSpeed <em>Speed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.CANBusImpl#getDataSpeed <em>Data Speed</em>}</li>
 * </ul>
 *
 * @generated
 */
public class CANBusImpl extends BusImpl implements CANBus {
	/**
	 * The default value of the '{@link #isLogEnabled() <em>Log Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isLogEnabled()
	 * @generated
	 * @ordered
	 */
	protected static final boolean LOG_ENABLED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isLogEnabled() <em>Log Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isLogEnabled()
	 * @generated
	 * @ordered
	 */
	protected boolean logEnabled = LOG_ENABLED_EDEFAULT;

	/**
	 * The default value of the '{@link #getSpeed() <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpeed()
	 * @generated
	 * @ordered
	 */
	protected static final int SPEED_EDEFAULT = 250000;

	/**
	 * The cached value of the '{@link #getSpeed() <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpeed()
	 * @generated
	 * @ordered
	 */
	protected int speed = SPEED_EDEFAULT;

	/**
	 * The default value of the '{@link #getDataSpeed() <em>Data Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataSpeed()
	 * @generated
	 * @ordered
	 */
	protected static final int DATA_SPEED_EDEFAULT = 250000;

	/**
	 * The cached value of the '{@link #getDataSpeed() <em>Data Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataSpeed()
	 * @generated
	 * @ordered
	 */
	protected int dataSpeed = DATA_SPEED_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CANBusImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PeripheralPackage.Literals.CAN_BUS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isLogEnabled() {
		return logEnabled;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLogEnabled(boolean newLogEnabled) {
		boolean oldLogEnabled = logEnabled;
		logEnabled = newLogEnabled;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.CAN_BUS__LOG_ENABLED, oldLogEnabled, logEnabled));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getSpeed() {
		return speed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSpeed(int newSpeed) {
		int oldSpeed = speed;
		speed = newSpeed;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.CAN_BUS__SPEED, oldSpeed, speed));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getDataSpeed() {
		return dataSpeed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDataSpeed(int newDataSpeed) {
		int oldDataSpeed = dataSpeed;
		dataSpeed = newDataSpeed;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.CAN_BUS__DATA_SPEED, oldDataSpeed, dataSpeed));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PeripheralPackage.CAN_BUS__LOG_ENABLED:
				return isLogEnabled();
			case PeripheralPackage.CAN_BUS__SPEED:
				return getSpeed();
			case PeripheralPackage.CAN_BUS__DATA_SPEED:
				return getDataSpeed();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PeripheralPackage.CAN_BUS__LOG_ENABLED:
				setLogEnabled((Boolean)newValue);
				return;
			case PeripheralPackage.CAN_BUS__SPEED:
				setSpeed((Integer)newValue);
				return;
			case PeripheralPackage.CAN_BUS__DATA_SPEED:
				setDataSpeed((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PeripheralPackage.CAN_BUS__LOG_ENABLED:
				setLogEnabled(LOG_ENABLED_EDEFAULT);
				return;
			case PeripheralPackage.CAN_BUS__SPEED:
				setSpeed(SPEED_EDEFAULT);
				return;
			case PeripheralPackage.CAN_BUS__DATA_SPEED:
				setDataSpeed(DATA_SPEED_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PeripheralPackage.CAN_BUS__LOG_ENABLED:
				return logEnabled != LOG_ENABLED_EDEFAULT;
			case PeripheralPackage.CAN_BUS__SPEED:
				return speed != SPEED_EDEFAULT;
			case PeripheralPackage.CAN_BUS__DATA_SPEED:
				return dataSpeed != DATA_SPEED_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (logEnabled: ");
		result.append(logEnabled);
		result.append(", speed: ");
		result.append(speed);
		result.append(", dataSpeed: ");
		result.append(dataSpeed);
		result.append(')');
		return result.toString();
	}

} //CANBusImpl
