/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import com.inchron.realtime.root.model.EventChain;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Event Chain Join Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventChainJoinRequirement#isAllowSameInstance <em>Allow Same Instance</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventChainJoinRequirement#getEventChain <em>Event Chain</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainJoinRequirement()
 * @model
 * @generated
 */
public interface EventChainJoinRequirement extends Requirement {
	/**
	 * Returns the value of the '<em><b>Allow Same Instance</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Allow Same Instance</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Allow Same Instance</em>' attribute.
	 * @see #setAllowSameInstance(boolean)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainJoinRequirement_AllowSameInstance()
	 * @model default="true"
	 * @generated
	 */
	boolean isAllowSameInstance();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventChainJoinRequirement#isAllowSameInstance <em>Allow Same Instance</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Allow Same Instance</em>' attribute.
	 * @see #isAllowSameInstance()
	 * @generated
	 */
	void setAllowSameInstance(boolean value);

	/**
	 * Returns the value of the '<em><b>Event Chain</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event Chain</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Chain</em>' reference.
	 * @see #setEventChain(EventChain)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainJoinRequirement_EventChain()
	 * @model required="true"
	 * @generated
	 */
	EventChain getEventChain();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventChainJoinRequirement#getEventChain <em>Event Chain</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Event Chain</em>' reference.
	 * @see #getEventChain()
	 * @generated
	 */
	void setEventChain(EventChain value);

} // EventChainJoinRequirement
