/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import com.inchron.realtime.root.model.EventChain;
import com.inchron.realtime.root.model.EventChainStep;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Event Chain Timing Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getEventChain <em>Event Chain</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getFromStep <em>From Step</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getInstanceOffset <em>Instance Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getStrategy <em>Strategy</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getToStep <em>To Step</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainTimingRequirement()
 * @model
 * @generated
 */
public interface EventChainTimingRequirement extends TimingRequirement {
	/**
	 * Returns the value of the '<em><b>Event Chain</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event Chain</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Chain</em>' reference.
	 * @see #setEventChain(EventChain)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainTimingRequirement_EventChain()
	 * @model required="true"
	 * @generated
	 */
	EventChain getEventChain();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getEventChain <em>Event Chain</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Event Chain</em>' reference.
	 * @see #getEventChain()
	 * @generated
	 */
	void setEventChain(EventChain value);

	/**
	 * Returns the value of the '<em><b>From Step</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>From Step</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>From Step</em>' reference.
	 * @see #setFromStep(EventChainStep)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainTimingRequirement_FromStep()
	 * @model required="true"
	 * @generated
	 */
	EventChainStep getFromStep();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getFromStep <em>From Step</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>From Step</em>' reference.
	 * @see #getFromStep()
	 * @generated
	 */
	void setFromStep(EventChainStep value);

	/**
	 * Returns the value of the '<em><b>Instance Offset</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Instance Offset</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Instance Offset</em>' attribute.
	 * @see #setInstanceOffset(int)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainTimingRequirement_InstanceOffset()
	 * @model default="0"
	 * @generated
	 */
	int getInstanceOffset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getInstanceOffset <em>Instance Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Instance Offset</em>' attribute.
	 * @see #getInstanceOffset()
	 * @generated
	 */
	void setInstanceOffset(int value);

	/**
	 * Returns the value of the '<em><b>Strategy</b></em>' attribute.
	 * The default value is <code>"FirstFirst"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.requirement.EventChainStrategy}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Strategy</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Strategy</em>' attribute.
	 * @see com.inchron.realtime.root.model.requirement.EventChainStrategy
	 * @see #setStrategy(EventChainStrategy)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainTimingRequirement_Strategy()
	 * @model default="FirstFirst"
	 * @generated
	 */
	EventChainStrategy getStrategy();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getStrategy <em>Strategy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Strategy</em>' attribute.
	 * @see com.inchron.realtime.root.model.requirement.EventChainStrategy
	 * @see #getStrategy()
	 * @generated
	 */
	void setStrategy(EventChainStrategy value);

	/**
	 * Returns the value of the '<em><b>To Step</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>To Step</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>To Step</em>' reference.
	 * @see #setToStep(EventChainStep)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainTimingRequirement_ToStep()
	 * @model required="true"
	 * @generated
	 */
	EventChainStep getToStep();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getToStep <em>To Step</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>To Step</em>' reference.
	 * @see #getToStep()
	 * @generated
	 */
	void setToStep(EventChainStep value);

} // EventChainTimingRequirement
