/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Rtos Failure Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.RtosFailureRequirement#getEnabledRTOSFailures <em>Enabled RTOS Failures</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.RtosFailureRequirement#getBlacklist <em>Blacklist</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getRtosFailureRequirement()
 * @model
 * @generated
 */
public interface RtosFailureRequirement extends Requirement {
	/**
	 * Returns the value of the '<em><b>Enabled RTOS Failures</b></em>' attribute list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.requirement.RTOSFailure}.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.requirement.RTOSFailure}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Enabled RTOS Failures</em>' attribute list.
	 * @see com.inchron.realtime.root.model.requirement.RTOSFailure
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getRtosFailureRequirement_EnabledRTOSFailures()
	 * @model
	 * @generated
	 */
	EList<RTOSFailure> getEnabledRTOSFailures();

	/**
	 * Returns the value of the '<em><b>Blacklist</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Process}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Blacklist</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Blacklist</em>' reference list.
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getRtosFailureRequirement_Blacklist()
	 * @model
	 * @generated
	 */
	EList<com.inchron.realtime.root.model.Process> getBlacklist();

} // RtosFailureRequirement
