/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.TraceEvent;

import com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement;
import com.inchron.realtime.root.model.requirement.RequirementPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Event Net Exec Time Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventNetExecTimeRequirementImpl#getEnd <em>End</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventNetExecTimeRequirementImpl#getProcess <em>Process</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventNetExecTimeRequirementImpl#getStart <em>Start</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EventNetExecTimeRequirementImpl extends TimingRequirementImpl implements EventNetExecTimeRequirement {
	/**
	 * The cached value of the '{@link #getEnd() <em>End</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEnd()
	 * @generated
	 * @ordered
	 */
	protected TraceEvent end;

	/**
	 * The cached value of the '{@link #getProcess() <em>Process</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProcess()
	 * @generated
	 * @ordered
	 */
	protected com.inchron.realtime.root.model.Process process;

	/**
	 * The cached value of the '{@link #getStart() <em>Start</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStart()
	 * @generated
	 * @ordered
	 */
	protected TraceEvent start;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EventNetExecTimeRequirementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RequirementPackage.Literals.EVENT_NET_EXEC_TIME_REQUIREMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent getEnd() {
		if (end != null && end.eIsProxy()) {
			InternalEObject oldEnd = (InternalEObject)end;
			end = (TraceEvent)eResolveProxy(oldEnd);
			if (end != oldEnd) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__END, oldEnd, end));
			}
		}
		return end;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent basicGetEnd() {
		return end;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEnd(TraceEvent newEnd) {
		TraceEvent oldEnd = end;
		end = newEnd;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__END, oldEnd, end));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.Process getProcess() {
		if (process != null && process.eIsProxy()) {
			InternalEObject oldProcess = (InternalEObject)process;
			process = (com.inchron.realtime.root.model.Process)eResolveProxy(oldProcess);
			if (process != oldProcess) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__PROCESS, oldProcess, process));
			}
		}
		return process;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.Process basicGetProcess() {
		return process;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProcess(com.inchron.realtime.root.model.Process newProcess) {
		com.inchron.realtime.root.model.Process oldProcess = process;
		process = newProcess;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__PROCESS, oldProcess, process));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent getStart() {
		if (start != null && start.eIsProxy()) {
			InternalEObject oldStart = (InternalEObject)start;
			start = (TraceEvent)eResolveProxy(oldStart);
			if (start != oldStart) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__START, oldStart, start));
			}
		}
		return start;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent basicGetStart() {
		return start;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStart(TraceEvent newStart) {
		TraceEvent oldStart = start;
		start = newStart;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__START, oldStart, start));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__END:
				if (resolve) return getEnd();
				return basicGetEnd();
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__PROCESS:
				if (resolve) return getProcess();
				return basicGetProcess();
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__START:
				if (resolve) return getStart();
				return basicGetStart();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__END:
				setEnd((TraceEvent)newValue);
				return;
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__PROCESS:
				setProcess((com.inchron.realtime.root.model.Process)newValue);
				return;
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__START:
				setStart((TraceEvent)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__END:
				setEnd((TraceEvent)null);
				return;
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__PROCESS:
				setProcess((com.inchron.realtime.root.model.Process)null);
				return;
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__START:
				setStart((TraceEvent)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__END:
				return end != null;
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__PROCESS:
				return process != null;
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT__START:
				return start != null;
		}
		return super.eIsSet(featureID);
	}

} //EventNetExecTimeRequirementImpl
