/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.LoadResource;
import com.inchron.realtime.root.model.Time;

import com.inchron.realtime.root.model.requirement.LoadRequirement;
import com.inchron.realtime.root.model.requirement.RelationalOperatorLeGe;
import com.inchron.realtime.root.model.requirement.RequirementPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Load Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.LoadRequirementImpl#getGranularity <em>Granularity</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.LoadRequirementImpl#getLimit <em>Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.LoadRequirementImpl#getLoadResource <em>Load Resource</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.LoadRequirementImpl#getPrewarnMargin <em>Prewarn Margin</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.LoadRequirementImpl#getRelationalOperator <em>Relational Operator</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.LoadRequirementImpl#getSteps <em>Steps</em>}</li>
 * </ul>
 *
 * @generated
 */
public class LoadRequirementImpl extends RequirementImpl implements LoadRequirement {
	/**
	 * The cached value of the '{@link #getGranularity() <em>Granularity</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGranularity()
	 * @generated
	 * @ordered
	 */
	protected Time granularity;

	/**
	 * The default value of the '{@link #getLimit() <em>Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLimit()
	 * @generated
	 * @ordered
	 */
	protected static final float LIMIT_EDEFAULT = 80.0F;

	/**
	 * The cached value of the '{@link #getLimit() <em>Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLimit()
	 * @generated
	 * @ordered
	 */
	protected float limit = LIMIT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getLoadResource() <em>Load Resource</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLoadResource()
	 * @generated
	 * @ordered
	 */
	protected LoadResource loadResource;

	/**
	 * The default value of the '{@link #getPrewarnMargin() <em>Prewarn Margin</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrewarnMargin()
	 * @generated
	 * @ordered
	 */
	protected static final float PREWARN_MARGIN_EDEFAULT = 10.0F;

	/**
	 * The cached value of the '{@link #getPrewarnMargin() <em>Prewarn Margin</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrewarnMargin()
	 * @generated
	 * @ordered
	 */
	protected float prewarnMargin = PREWARN_MARGIN_EDEFAULT;

	/**
	 * The default value of the '{@link #getRelationalOperator() <em>Relational Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRelationalOperator()
	 * @generated
	 * @ordered
	 */
	protected static final RelationalOperatorLeGe RELATIONAL_OPERATOR_EDEFAULT = RelationalOperatorLeGe.LE;

	/**
	 * The cached value of the '{@link #getRelationalOperator() <em>Relational Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRelationalOperator()
	 * @generated
	 * @ordered
	 */
	protected RelationalOperatorLeGe relationalOperator = RELATIONAL_OPERATOR_EDEFAULT;

	/**
	 * The default value of the '{@link #getSteps() <em>Steps</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSteps()
	 * @generated
	 * @ordered
	 */
	protected static final int STEPS_EDEFAULT = 20;

	/**
	 * The cached value of the '{@link #getSteps() <em>Steps</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSteps()
	 * @generated
	 * @ordered
	 */
	protected int steps = STEPS_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LoadRequirementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RequirementPackage.Literals.LOAD_REQUIREMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getGranularity() {
		return granularity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetGranularity(Time newGranularity, NotificationChain msgs) {
		Time oldGranularity = granularity;
		granularity = newGranularity;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, RequirementPackage.LOAD_REQUIREMENT__GRANULARITY, oldGranularity, newGranularity);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGranularity(Time newGranularity) {
		if (newGranularity != granularity) {
			NotificationChain msgs = null;
			if (granularity != null)
				msgs = ((InternalEObject)granularity).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - RequirementPackage.LOAD_REQUIREMENT__GRANULARITY, null, msgs);
			if (newGranularity != null)
				msgs = ((InternalEObject)newGranularity).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - RequirementPackage.LOAD_REQUIREMENT__GRANULARITY, null, msgs);
			msgs = basicSetGranularity(newGranularity, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.LOAD_REQUIREMENT__GRANULARITY, newGranularity, newGranularity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public float getLimit() {
		return limit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLimit(float newLimit) {
		float oldLimit = limit;
		limit = newLimit;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.LOAD_REQUIREMENT__LIMIT, oldLimit, limit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LoadResource getLoadResource() {
		if (loadResource != null && loadResource.eIsProxy()) {
			InternalEObject oldLoadResource = (InternalEObject)loadResource;
			loadResource = (LoadResource)eResolveProxy(oldLoadResource);
			if (loadResource != oldLoadResource) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.LOAD_REQUIREMENT__LOAD_RESOURCE, oldLoadResource, loadResource));
			}
		}
		return loadResource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LoadResource basicGetLoadResource() {
		return loadResource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLoadResource(LoadResource newLoadResource) {
		LoadResource oldLoadResource = loadResource;
		loadResource = newLoadResource;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.LOAD_REQUIREMENT__LOAD_RESOURCE, oldLoadResource, loadResource));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public float getPrewarnMargin() {
		return prewarnMargin;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPrewarnMargin(float newPrewarnMargin) {
		float oldPrewarnMargin = prewarnMargin;
		prewarnMargin = newPrewarnMargin;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.LOAD_REQUIREMENT__PREWARN_MARGIN, oldPrewarnMargin, prewarnMargin));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RelationalOperatorLeGe getRelationalOperator() {
		return relationalOperator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRelationalOperator(RelationalOperatorLeGe newRelationalOperator) {
		RelationalOperatorLeGe oldRelationalOperator = relationalOperator;
		relationalOperator = newRelationalOperator == null ? RELATIONAL_OPERATOR_EDEFAULT : newRelationalOperator;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.LOAD_REQUIREMENT__RELATIONAL_OPERATOR, oldRelationalOperator, relationalOperator));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getSteps() {
		return steps;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSteps(int newSteps) {
		int oldSteps = steps;
		steps = newSteps;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.LOAD_REQUIREMENT__STEPS, oldSteps, steps));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RequirementPackage.LOAD_REQUIREMENT__GRANULARITY:
				return basicSetGranularity(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RequirementPackage.LOAD_REQUIREMENT__GRANULARITY:
				return getGranularity();
			case RequirementPackage.LOAD_REQUIREMENT__LIMIT:
				return getLimit();
			case RequirementPackage.LOAD_REQUIREMENT__LOAD_RESOURCE:
				if (resolve) return getLoadResource();
				return basicGetLoadResource();
			case RequirementPackage.LOAD_REQUIREMENT__PREWARN_MARGIN:
				return getPrewarnMargin();
			case RequirementPackage.LOAD_REQUIREMENT__RELATIONAL_OPERATOR:
				return getRelationalOperator();
			case RequirementPackage.LOAD_REQUIREMENT__STEPS:
				return getSteps();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RequirementPackage.LOAD_REQUIREMENT__GRANULARITY:
				setGranularity((Time)newValue);
				return;
			case RequirementPackage.LOAD_REQUIREMENT__LIMIT:
				setLimit((Float)newValue);
				return;
			case RequirementPackage.LOAD_REQUIREMENT__LOAD_RESOURCE:
				setLoadResource((LoadResource)newValue);
				return;
			case RequirementPackage.LOAD_REQUIREMENT__PREWARN_MARGIN:
				setPrewarnMargin((Float)newValue);
				return;
			case RequirementPackage.LOAD_REQUIREMENT__RELATIONAL_OPERATOR:
				setRelationalOperator((RelationalOperatorLeGe)newValue);
				return;
			case RequirementPackage.LOAD_REQUIREMENT__STEPS:
				setSteps((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RequirementPackage.LOAD_REQUIREMENT__GRANULARITY:
				setGranularity((Time)null);
				return;
			case RequirementPackage.LOAD_REQUIREMENT__LIMIT:
				setLimit(LIMIT_EDEFAULT);
				return;
			case RequirementPackage.LOAD_REQUIREMENT__LOAD_RESOURCE:
				setLoadResource((LoadResource)null);
				return;
			case RequirementPackage.LOAD_REQUIREMENT__PREWARN_MARGIN:
				setPrewarnMargin(PREWARN_MARGIN_EDEFAULT);
				return;
			case RequirementPackage.LOAD_REQUIREMENT__RELATIONAL_OPERATOR:
				setRelationalOperator(RELATIONAL_OPERATOR_EDEFAULT);
				return;
			case RequirementPackage.LOAD_REQUIREMENT__STEPS:
				setSteps(STEPS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RequirementPackage.LOAD_REQUIREMENT__GRANULARITY:
				return granularity != null;
			case RequirementPackage.LOAD_REQUIREMENT__LIMIT:
				return limit != LIMIT_EDEFAULT;
			case RequirementPackage.LOAD_REQUIREMENT__LOAD_RESOURCE:
				return loadResource != null;
			case RequirementPackage.LOAD_REQUIREMENT__PREWARN_MARGIN:
				return prewarnMargin != PREWARN_MARGIN_EDEFAULT;
			case RequirementPackage.LOAD_REQUIREMENT__RELATIONAL_OPERATOR:
				return relationalOperator != RELATIONAL_OPERATOR_EDEFAULT;
			case RequirementPackage.LOAD_REQUIREMENT__STEPS:
				return steps != STEPS_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (limit: ");
		result.append(limit);
		result.append(", prewarnMargin: ");
		result.append(prewarnMargin);
		result.append(", relationalOperator: ");
		result.append(relationalOperator);
		result.append(", steps: ");
		result.append(steps);
		result.append(')');
		return result.toString();
	}

} //LoadRequirementImpl
