/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation.impl;

import com.inchron.realtime.root.model.Time;

import com.inchron.realtime.root.model.stimulation.DisturbanceFilter;
import com.inchron.realtime.root.model.stimulation.StimulationPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Disturbance Filter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.DisturbanceFilterImpl#getDisturbanceProbability <em>Disturbance Probability</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.DisturbanceFilterImpl#getDisturbanceSigma <em>Disturbance Sigma</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.DisturbanceFilterImpl#getLossProbability <em>Loss Probability</em>}</li>
 * </ul>
 *
 * @generated
 */
public class DisturbanceFilterImpl extends StimulationFilterImpl implements DisturbanceFilter {
	/**
	 * The default value of the '{@link #getDisturbanceProbability() <em>Disturbance Probability</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisturbanceProbability()
	 * @generated
	 * @ordered
	 */
	protected static final float DISTURBANCE_PROBABILITY_EDEFAULT = 0.0F;

	/**
	 * The cached value of the '{@link #getDisturbanceProbability() <em>Disturbance Probability</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisturbanceProbability()
	 * @generated
	 * @ordered
	 */
	protected float disturbanceProbability = DISTURBANCE_PROBABILITY_EDEFAULT;

	/**
	 * The cached value of the '{@link #getDisturbanceSigma() <em>Disturbance Sigma</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisturbanceSigma()
	 * @generated
	 * @ordered
	 */
	protected Time disturbanceSigma;

	/**
	 * The default value of the '{@link #getLossProbability() <em>Loss Probability</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLossProbability()
	 * @generated
	 * @ordered
	 */
	protected static final float LOSS_PROBABILITY_EDEFAULT = 0.0F;

	/**
	 * The cached value of the '{@link #getLossProbability() <em>Loss Probability</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLossProbability()
	 * @generated
	 * @ordered
	 */
	protected float lossProbability = LOSS_PROBABILITY_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DisturbanceFilterImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return StimulationPackage.Literals.DISTURBANCE_FILTER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public float getDisturbanceProbability() {
		return disturbanceProbability;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDisturbanceProbability(float newDisturbanceProbability) {
		float oldDisturbanceProbability = disturbanceProbability;
		disturbanceProbability = newDisturbanceProbability;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_PROBABILITY, oldDisturbanceProbability, disturbanceProbability));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getDisturbanceSigma() {
		return disturbanceSigma;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDisturbanceSigma(Time newDisturbanceSigma, NotificationChain msgs) {
		Time oldDisturbanceSigma = disturbanceSigma;
		disturbanceSigma = newDisturbanceSigma;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_SIGMA, oldDisturbanceSigma, newDisturbanceSigma);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDisturbanceSigma(Time newDisturbanceSigma) {
		if (newDisturbanceSigma != disturbanceSigma) {
			NotificationChain msgs = null;
			if (disturbanceSigma != null)
				msgs = ((InternalEObject)disturbanceSigma).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_SIGMA, null, msgs);
			if (newDisturbanceSigma != null)
				msgs = ((InternalEObject)newDisturbanceSigma).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_SIGMA, null, msgs);
			msgs = basicSetDisturbanceSigma(newDisturbanceSigma, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_SIGMA, newDisturbanceSigma, newDisturbanceSigma));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public float getLossProbability() {
		return lossProbability;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLossProbability(float newLossProbability) {
		float oldLossProbability = lossProbability;
		lossProbability = newLossProbability;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.DISTURBANCE_FILTER__LOSS_PROBABILITY, oldLossProbability, lossProbability));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_SIGMA:
				return basicSetDisturbanceSigma(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_PROBABILITY:
				return getDisturbanceProbability();
			case StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_SIGMA:
				return getDisturbanceSigma();
			case StimulationPackage.DISTURBANCE_FILTER__LOSS_PROBABILITY:
				return getLossProbability();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_PROBABILITY:
				setDisturbanceProbability((Float)newValue);
				return;
			case StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_SIGMA:
				setDisturbanceSigma((Time)newValue);
				return;
			case StimulationPackage.DISTURBANCE_FILTER__LOSS_PROBABILITY:
				setLossProbability((Float)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_PROBABILITY:
				setDisturbanceProbability(DISTURBANCE_PROBABILITY_EDEFAULT);
				return;
			case StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_SIGMA:
				setDisturbanceSigma((Time)null);
				return;
			case StimulationPackage.DISTURBANCE_FILTER__LOSS_PROBABILITY:
				setLossProbability(LOSS_PROBABILITY_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_PROBABILITY:
				return disturbanceProbability != DISTURBANCE_PROBABILITY_EDEFAULT;
			case StimulationPackage.DISTURBANCE_FILTER__DISTURBANCE_SIGMA:
				return disturbanceSigma != null;
			case StimulationPackage.DISTURBANCE_FILTER__LOSS_PROBABILITY:
				return lossProbability != LOSS_PROBABILITY_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (disturbanceProbability: ");
		result.append(disturbanceProbability);
		result.append(", lossProbability: ");
		result.append(lossProbability);
		result.append(')');
		return result.toString();
	}

} //DisturbanceFilterImpl
