/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.settings;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.settings.SettingsPackage
 * @generated
 */
public interface SettingsFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SettingsFactory eINSTANCE = com.inchron.realtime.root.settings.impl.SettingsFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Color</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Color</em>'.
	 * @generated
	 */
	Color createColor();

	/**
	 * Returns a new object of class '<em>Color Entry</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Color Entry</em>'.
	 * @generated
	 */
	ColorEntry createColorEntry();

	/**
	 * Returns a new object of class '<em>Color Entry Container</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Color Entry Container</em>'.
	 * @generated
	 */
	ColorEntryContainer createColorEntryContainer();

	/**
	 * Returns a new object of class '<em>Cursor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Cursor</em>'.
	 * @generated
	 */
	Cursor createCursor();

	/**
	 * Returns a new object of class '<em>Diagram Settings</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Diagram Settings</em>'.
	 * @generated
	 */
	DiagramSettings createDiagramSettings();

	/**
	 * Returns a new object of class '<em>Editor Settings</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Editor Settings</em>'.
	 * @generated
	 */
	EditorSettings createEditorSettings();

	/**
	 * Returns a new object of class '<em>EObject Flag</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EObject Flag</em>'.
	 * @generated
	 */
	EObjectFlag createEObjectFlag();

	/**
	 * Returns a new object of class '<em>Model Object Flag</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Model Object Flag</em>'.
	 * @generated
	 */
	ModelObjectFlag createModelObjectFlag();

	/**
	 * Returns a new object of class '<em>Model Settings</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Model Settings</em>'.
	 * @generated
	 */
	ModelSettings createModelSettings();

	/**
	 * Returns a new object of class '<em>Random Seed</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Random Seed</em>'.
	 * @generated
	 */
	RandomSeed createRandomSeed();

	/**
	 * Returns a new object of class '<em>Settings</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Settings</em>'.
	 * @generated
	 */
	Settings createSettings();

	/**
	 * Returns a new object of class '<em>Simulation Settings</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Simulation Settings</em>'.
	 * @generated
	 */
	SimulationSettings createSimulationSettings();

	/**
	 * Returns a new object of class '<em>Tool Settings</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Tool Settings</em>'.
	 * @generated
	 */
	ToolSettings createToolSettings();

	/**
	 * Returns a new object of class '<em>Trace Event Type Configuration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Trace Event Type Configuration</em>'.
	 * @generated
	 */
	TraceEventTypeConfiguration createTraceEventTypeConfiguration();

	/**
	 * Returns a new object of class '<em>View Settings</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>View Settings</em>'.
	 * @generated
	 */
	ViewSettings createViewSettings();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	SettingsPackage getSettingsPackage();

} //SettingsFactory
