/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.settings;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Simulation Settings</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.settings.SimulationSettings#getRandomSeed <em>Random Seed</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.settings.SettingsPackage#getSimulationSettings()
 * @model
 * @generated
 */
public interface SimulationSettings extends EObject {
	/**
	 * Returns the value of the '<em><b>Random Seed</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Random Seed</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Random Seed</em>' containment reference.
	 * @see #setRandomSeed(RandomSeed)
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getSimulationSettings_RandomSeed()
	 * @model containment="true" required="true"
	 * @generated
	 */
	RandomSeed getRandomSeed();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.settings.SimulationSettings#getRandomSeed <em>Random Seed</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Random Seed</em>' containment reference.
	 * @see #getRandomSeed()
	 * @generated
	 */
	void setRandomSeed(RandomSeed value);

} // SimulationSettings
