/**
 * *******************************************************************************
 * Copyright (c) 2019 Robert Bosch GmbH and others.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     Robert Bosch GmbH - initial API and implementation
 * *******************************************************************************
 */

package templates.m2m.hw

import com.google.inject.Inject
import com.inchron.realtime.root.model.memory.MemoryType
import org.eclipse.app4mc.amalthea.model.Cache
import templates.AbstractAmaltheaInchronTransformer
import com.google.inject.Singleton

@Singleton
class CacheTransformer extends AbstractAmaltheaInchronTransformer {
	
	@Inject FrequencyDomainTransformer frequencyDomainTransformer

	def create inchronMemoryFactory.createMemory createCache(Cache amltCache) {

		it.name = amltCache.name

		it.clock = frequencyDomainTransformer.createClock(amltCache.frequencyDomain)

		it.type = MemoryType.CACHE
	}
	

}
